// LyricWnd.h: interface for the CKayLyricWnd class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __KAYLYRICWND_H__
#define __KAYLYRICWND_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define LYRICWND_CLASS_NAME		_T("KAY_LYRIC_WIN")
#define LYRICWND_TITLE			_T("Lyrics")


class CMainWnd;
class CKayPpcMainWnd;
class CKayLyricWnd
{
	friend CKayPpcMainWnd;
	friend class CKayWin32MainWnd;

public:
	int CalcCurrentLyricPos();
	void SetReDraw(BOOL fErase);
	CKayLyricWnd();
	virtual ~CKayLyricWnd();
	virtual void Show(CMainWnd* pParent, BOOL fShow = TRUE);
	virtual void Close();
	virtual BOOL LoadLyric(int iPos, FILEINFO* pInfo);
	virtual BOOL IsLyricLoaded() {return m_fLyricLoadOK;}
	virtual void SetLyricSyncShift(int iTimeShift);
	virtual void SetLyricSyncReset();
	virtual BOOL Open(int nIndex, FILEINFO* pInfo);
	virtual BOOL Play(int nIndex = OPEN_NONE);
	virtual void Stop();
	virtual void ChangeTitle(LPTSTR str);
	virtual void OnSize(UINT nType, int cx, int cy);
//	virtual void UpdateLyric();
//	virtual void SetCurrent(int nIndex);
//	virtual BOOL IsDialogMessage(LPMSG pMsg);

public:
	virtual int  GetDisplayLines() {return m_nDisplayLines;}
	virtual void SetDisplayLines(int nLines) {m_nDisplayLines=nLines;}
	virtual COptions* GetOptions(){return GetPlayerApp()->GetMainWnd()->m_pOptions;}

protected:
	static BOOL CALLBACK LyricWndProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual BOOL Create(LPTSTR pszCmdLine = NULL, HWND hwndParent = NULL, DWORD dwStyle = WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX);
	virtual void RegisterClass();
	virtual void DrawLyric(HDC hDC);
	virtual void DrawLyric2(HDC hDC, int iIndex);
	virtual BOOL ParseLyric(LPTSTR szLyric);
	virtual BOOL ParseLyricFile2(LPTSTR szLyricFileName);
	virtual BOOL ParseLyricFile(LPTSTR szLyricFileName);
	virtual BOOL ParseLyricFromString(LPTSTR szLyricString);
	virtual BOOL DeleteLyricList();

//	virtual void ShowMenu(int x, int y);
//	void AddLyric(HWND hwndLV, int nIndex);

protected:
	virtual void OnCreate(HWND hWnd);
	virtual void OnTimer(UINT uID);
	virtual void OnPaint(HDC hDC, PAINTSTRUCT* pps);
//	void OnMove(int x, int y);
//	void OnAdd();
//	void OnUp(BOOL fVisible = TRUE);
//	void OnDown(BOOL fVisible = TRUE);
//	void OnDelete();
//	void OnSave();
//	void OnOK();
//	void OnSort(UINT uID);
//	void OnLyricKeyDown(NMLVKEYDOWN* pnm);
//	void OnLyricDblClk(NMHDR* pnm);
//	void OnLyricClick(NMHDR* pnm);
//	void OnLyricRClick(NMHDR* pnm);
//	void OnLyricBeginDrag(NMLISTVIEW* pnmlv);
//	void OnMouseMove(int x, int y);
//	void OnLButtonUp();
#ifndef _WIN32_WCE
//	void OnDropFiles(HDROP hDrop);
#endif


protected:
	HWND		m_hWnd;
	CMainWnd*	m_pParent;
//	HIMAGELIST	m_hImageList;
	HBRUSH		m_hBrush;
	HFONT		m_hFont;

	CMultiBuff*	m_pLyricList;
	int			m_iLyricPos;
	LPTSTR		m_pszAlbum;
	LPTSTR		m_pszTitle;
	LPTSTR		m_pszArtist;
	LPTSTR		m_pszLyricInfo;
	BOOL		m_fLyricDrag;
	BOOL		m_fLyricLoadOK;
	BOOL		m_fLyricWordWrap;
	int			m_nDragItem;
	int			m_nDisplayLines;
	int			m_iTimeShift; //msec

public:
	struct LYRIC_INFO{
		UINT uTime;//ms
		LPTSTR szLyric;//one line
		LYRIC_INFO(UINT uTime = 0, LPTSTR szLyric = NULL) {
			this->uTime = uTime;
			this->szLyric = szLyric;
			TRACE2("[%06d]%s\n", uTime, szLyric);
		}
		~LYRIC_INFO() {
			if(szLyric) delete[] szLyric;
		}
	};

protected:
	static int CALLBACK LyricCompare(LYRIC_INFO* pLeft, LYRIC_INFO* pRight, CKayLyricWnd* pLyricWnd);
};

#endif // __KAYLYRICWND_H__
