#ifndef __KAYMAINWND_H__
#define __KAYMAINWND_H__

#include "MainWnd.h"

#define     ID_TIMER_REPEAT_LOOP            (ID_TIMER_SLEEPTIMER+1)
#define		TIMER_REPEAT_LOOP_INTERVAL		3000

class CKayMainWnd : public CMainWnd
{
	friend COptions;
	friend class CKayOptions;
public:
	CKayMainWnd();
	virtual ~CKayMainWnd();

public:
	virtual void ChangeTitle(LPTSTR str);
	HANDLE GetMapHandle() {return m_hMap;}

protected: // overrides
//	virtual void OnCreate(HWND hWnd);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void OnToolOption();
	virtual void OnPlayRepeat();
	virtual void OnPlayRew();
	virtual void OnPlayFf();

	static LRESULT CALLBACK KayMainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

protected: // overrides
	virtual MMRESULT waveOutGetVolume(HWAVEOUT hwo, LPDWORD pdwVolume);
	virtual MMRESULT waveOutSetVolume(HWAVEOUT hwo, DWORD dwVolume);
	virtual void RegisterClass();
	virtual BOOL Open(int nIndex);
	virtual BOOL Play(int nIndex = OPEN_NONE);
	virtual void OnTimer(UINT uID);
	virtual void DrawTitle(HDC hDC);
	virtual void Seek(int nMilisec);

protected: //messages
	virtual void OnInitMenuPopup(HMENU hMenu, UINT uPos, BOOL fSystemMenu);

protected: // implement
	virtual void DrawRepeatLoop(HDC hDC);
	virtual void OnPlayNextFolder();
	virtual void OnPlayPrevFolder();
	virtual int  GetNextFolderIndex();
	virtual int  GetPrevFolderIndex();
	virtual void OnRepeatLoop(int iMenu);
	virtual void RepeatLoopReset(BOOL fDisplay = FALSE);
	virtual int  InitVolume(DWORD dwVolume = 0);

	BOOL		m_fVolMuted;
	DWORD		m_dwVolSaved;
	BOOL		m_fDrawRepeatLoop;
	int			m_nRepeatLoopState;
    long		m_lRepeatLoopStart;
    long		m_lRepeatLoopEnd;
    long		m_lRepeatLoop_A;
    long		m_lRepeatLoop_B;
};

#endif // __KAYMAINWND_H__
