#include "GSPlayer2.h"
#include "KayWin32MainWnd.h"
#include "KayWin32Options.h"

#define ShowHideLyricWindow /##/

CKayWin32MainWnd::CKayWin32MainWnd()
{
	m_pLyricWnd = NULL;
	m_hWaveOut = NULL;
	m_bMayBeLyricWndVisible = FALSE;
	m_bAutoShowLyricWnd = TRUE;
	::waveOutGetVolume(NULL, &m_dwCurrentVolume);

	//÷ Ʈ  ߰
	m_hImageListPlayList = ImageList_Create(16, 16, ILC_COLOR | ILC_MASK, 2, 2);
	HICON hIcon = LoadIcon(GetInst(), LPCTSTR(IDI_FILE_S));
	ImageList_AddIcon(m_hImageListPlayList, hIcon);
	DestroyIcon(hIcon);
	hIcon = LoadIcon(GetInst(), LPCTSTR(IDI_PLAY_S));
	ImageList_AddIcon(m_hImageListPlayList, hIcon);
	DestroyIcon(hIcon);
}

CKayWin32MainWnd::~CKayWin32MainWnd()
{
	if(m_pLyricWnd) {
		m_pLyricWnd->Close();
		delete m_pLyricWnd;
		m_pLyricWnd = NULL;
	}

	//̹ Ʈ 
	ImageList_Destroy(m_hImageListPlayList);
}

COptions* CKayWin32MainWnd::GetOptionsClass()
{
	return new CKayWin32Options();
}

void CKayWin32MainWnd::OnClose()
{
	if (m_pLyricWnd) {
		m_pLyricWnd->Close();
		delete m_pLyricWnd;
		m_pLyricWnd = NULL;
	}
	__super::OnClose();
}

//void CKayWin32MainWnd::OnSize(UINT nType, int cx, int cy)
//{
//	DeleteImages();
//	InitImages();
//
//	RECT rc;
//	if(m_pLyricWnd) {
//		m_pLyricWnd->OnSize(nType, PPC_PLAYLIST_WIDTH, 45);
//	}
//	if( m_pLyricWnd && IsWindow(m_pLyricWnd->m_hWnd) && IsWindowVisible(m_pLyricWnd->m_hWnd) ) {
//		MoveWindow(m_hwndLV, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP+35, PPC_PLAYLIST_WIDTH, PPC_PLAYLIST_HEIGHT-35, TRUE);
//	} else {
//		MoveWindow(m_hwndLV, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP, PPC_PLAYLIST_WIDTH, PPC_PLAYLIST_HEIGHT, TRUE);
//	}
//	GetWindowRect(m_hwndLV, &rc);
//	SendMessage(m_hwndLV, LVM_SETCOLUMNWIDTH, 0, 
//		MAKELPARAM(RECT_WIDTH(&rc) - GetSystemMetrics(SM_CXVSCROLL) - GetSystemMetrics(SM_CXBORDER) * 2, 0));
//
//	InvalidateRect(m_hWnd, NULL, TRUE);
//	UpdateWindow(m_hWnd);
//}

//void CKayWin32MainWnd::ShowHideLyricWindow(BOOL bShow /*= TRUE*/)
//{
//	//ƹ â  ص, 츦  Ҷ
//	//ڵ ɼ , ׸ 簡 ε Ǿ̴.
//	if( bShow &&
//		m_bAutoShowLyricWnd &&
//		m_pLyricWnd &&
//		m_pLyricWnd->IsLyricLoaded() )
//	{
//		MoveWindow(m_hwndLV, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP+35, PPC_PLAYLIST_WIDTH, PPC_PLAYLIST_HEIGHT-35, TRUE);
//		m_pLyricWnd->Show(this);
//		m_bMayBeLyricWndVisible = TRUE;
//	}
//	else {
//		MoveWindow(m_hwndLV, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP, PPC_PLAYLIST_WIDTH, PPC_PLAYLIST_HEIGHT, TRUE);
//		if(m_pLyricWnd)  m_pLyricWnd->Show(this, FALSE);
//		m_bMayBeLyricWndVisible = FALSE;
//	}
//}

//COptions* CKayWin32MainWnd::GetOptionsClass()
//{
//	return new CPpcOptions();
//}

HACCEL CKayWin32MainWnd::GetAccelHandle()
{
	if (!m_hAccel) {
		ACCEL accel[] = {
			{FVIRTKEY | FCONTROL, 'Z', IDM_PLAY_PLAYPAUSE},		// Play/Pause
			{FVIRTKEY			, '5', IDM_PLAY_PLAYPAUSE},		// Play/Pause
			{FVIRTKEY | FCONTROL, 'X', IDM_PLAY_STOP},				// Stop
			{FVIRTKEY			, '0', IDM_PLAY_STOP},				// Stop
			{FVIRTKEY | FCONTROL, 'C', IDM_PLAY_PREV},				// Prev
			{FVIRTKEY			, '1', IDM_PLAY_PREV},				// Prev
			{FVIRTKEY | FCONTROL, 'V', IDM_PLAY_REW},				// Rew
			{FVIRTKEY			, '4', IDM_PLAY_REW},				// Rew
			{FVIRTKEY | FCONTROL, 'B', IDM_PLAY_FF},				// FF
			{FVIRTKEY			, '6', IDM_PLAY_FF},				// FF
			{FVIRTKEY | FCONTROL, 'N', IDM_PLAY_NEXT},				// Next
			{FVIRTKEY			, '3', IDM_PLAY_NEXT},				// Next
			{FVIRTKEY | FCONTROL, 'R', IDM_PLAY_REPEAT},			// Repeat
			{FVIRTKEY			, '7', IDM_PLAY_REPEAT},			// Repeat
			{FVIRTKEY | FCONTROL, 'H', IDM_PLAY_SHUFFLE},			// Shuffle
			{FVIRTKEY			, '9', IDM_PLAY_SHUFFLE},			// Shuffle
			{FVIRTKEY | FCONTROL, 'O', IDM_FILE_OPEN},				// Open
			{FVIRTKEY | FCONTROL, 'U', IDM_FILE_OPEN_LOCATION},	// Open Location
			{FVIRTKEY | FCONTROL, 'A', IDM_FILE_ADD},				// Add
			{FVIRTKEY			, '*', IDM_FILE_ADD},				// Add
			{FVIRTKEY | FCONTROL, 'F', IDM_FILE_FIND},				// Find
			{FVIRTKEY | FCONTROL, 'L', IDM_FILE_LIST},				// List
			{FVIRTKEY			, '#', IDM_FILE_LIST},				// List
			{FVIRTKEY | FCONTROL, 'S', IDM_FILE_SAVE_LIST},		// Save List
			{FVIRTKEY | FCONTROL, 'E', IDM_TOOL_EFFECT},			// Effect
			{FVIRTKEY | FCONTROL, 'Y', IDM_TOOL_VOLUP},			// Volume Up
			{FVIRTKEY			, '2', IDM_TOOL_VOLUP},			// Volume Up
			{FVIRTKEY | FCONTROL, 'T', IDM_TOOL_VOLDOWN},		// Volume Down
			{FVIRTKEY			, '8', IDM_TOOL_VOLDOWN},		// Volume Down
			{FVIRTKEY | FCONTROL, 'Q', IDM_APP_EXIT},	// Exit
		};
		m_hAccel = CreateAcceleratorTable(accel, sizeof(accel) / sizeof(ACCEL));
	}
	return m_hAccel;
}

void CKayWin32MainWnd::OnCreate(HWND hWnd)
{
	__super::OnCreate(hWnd);
	ChangeTitle(_T("KayPlayer"));

	if(!m_pLyricWnd) {
		m_pLyricWnd = new CKayLyricWnd();
		m_pLyricWnd->Show(this, FALSE);
	}
}

LRESULT CKayWin32MainWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)) {
		case IDM_APP_EXIT:
			PostMessage(m_hWnd, WM_CLOSE, 0, 0);
			return 0;
		case IDM_LYRIC_SHOWHIDE:
			{//â ̱/
				//ڵ  Ѵ.
				m_bAutoShowLyricWnd = !m_bAutoShowLyricWnd;
				//ڵ  ɼ ְ 簡 ε Ǿ ش.
				ShowHideLyricWindow();//try to show
			}
			return 0;
		case IDM_LYRIC_SYNC_PULL:
			if(m_pLyricWnd)
				m_pLyricWnd->SetLyricSyncShift(m_pOptions->m_iLyricShiftmsec);
			return 0;
		case IDM_LYRIC_SYNC_PUSH:
			if(m_pLyricWnd)
				m_pLyricWnd->SetLyricSyncShift(-(int)(m_pOptions->m_iLyricShiftmsec));
			return 0;
		case IDM_LYRIC_SYNC_RESET:
			if(m_pLyricWnd)
				m_pLyricWnd->SetLyricSyncReset();
			return 0;
	}
	return __super::OnCommand(wParam, lParam);
}

void CKayWin32MainWnd::OnToolOption()
{
	__super::OnToolOption();
}

//BOOL CKayWin32MainWnd::Open(int nIndex)
//{
//	BOOL fRet = __super::Open(nIndex);
//
//	//翭Ⱑ ϸ ְ ϸ 
//	if( fRet && m_pLyricWnd) {
//		if( m_pLyricWnd->Open(nIndex, ((nIndex==OPEN_NONE)?NULL:(FILEINFO*)m_pListFile->GetAt(nIndex))) ) {
//			ShowHideLyricWindow(TRUE);
//		}
//		else {
//			ShowHideLyricWindow(FALSE);
//		}
//	}
//
//	//Ʈ  Ʈ
//	UpdateListImage(nIndex);
//	ListView_EnsureVisible(m_hwndLV, nIndex, FALSE);//̰...
//
//	return fRet;
//}

//void CKayWin32MainWnd::UpdateListImage(int nIndex)
//{
//	const int nCount = ListView_GetItemCount(m_hwndLV);
//	for (int i = 0; i < nCount; i++) {
//		LVITEM li;
//		memset(&li, 0, sizeof(LVITEM));
//		li.mask = LVIF_IMAGE;
//		li.iItem = i;
//		ListView_GetItem(m_hwndLV, &li);
//		if (li.iImage && i != nIndex) {
//			li.iImage = 0;
//			ListView_SetItem(m_hwndLV, &li);
//		}
//		else if (i == nIndex) {
//			li.iImage = 1;
//			ListView_SetItem(m_hwndLV, &li);
//		}
//	}
//}

//void CKayWin32MainWnd::OnTimer(UINT uID)
//{
//	if (uID == ID_TIMER_CLICKCHECK) {
//		KillTimer(m_hWnd, ID_TIMER_CLICKCHECK);
//		if (m_ClickInfo.state==1) {
//			m_ClickInfo.state = 0;
//			ProcessHotKey(m_ClickInfo.nID, m_ClickInfo.modifiers, m_ClickInfo.virtKey, 0);
//		}
//	}
//	else
//		__super::OnTimer(uID);
//}

void CKayWin32MainWnd::Stop()
{
	__super::Stop();
	if(m_pLyricWnd)
		m_pLyricWnd->Stop();
}

BOOL CKayWin32MainWnd::Play(int nIndex)
{
	BOOL ret = __super::Play(nIndex);

	if(m_pLyricWnd)
		m_pLyricWnd->Play(nIndex);
 	return ret;
}

//void CKayWin32MainWnd::CreateListView()
//{
//	__super::CreateListView();
//
//	//̹ Ʈ
//	ListView_SetImageList(m_hwndLV, m_hImageListPlayList, LVSIL_SMALL);
//
//	RECT rc;
//	GetWindowRect(m_hwndLV, &rc);
//	int dx = RECT_WIDTH(&rc);
//	int dy = RECT_HEIGHT(&rc);
//	SetWindowPos (m_hwndLV, NULL, rc.left, rc.top, dx, dy, SWP_HIDEWINDOW );
//}

//void CKayWin32MainWnd::RegisterClass()
//{
//	WNDCLASS	wc;
//	memset(&wc, 0, sizeof(WNDCLASS));
//    wc.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
//    wc.lpfnWndProc = (WNDPROC)KayWin32MainWndProc;
//    wc.hInstance = GetInst();
//    wc.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
//    wc.lpszClassName = MAINWND_CLASS_NAME;
//	::RegisterClass(&wc);
//}

//LRESULT CALLBACK CKayWin32MainWnd::KayWin32MainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
//{
//	static CKayWin32MainWnd* pMainWnd = NULL;
//
//	switch (uMsg) {
//	case WM_CREATE:
//		CREATESTRUCT* pcs;
//		pcs = (CREATESTRUCT*)lParam;
//		pMainWnd = (CKayWin32MainWnd*)pcs->lpCreateParams;
//		return __super::Win32MainWndProc(hwnd, uMsg, wParam, lParam);
//	case MM_WIM_OPEN://۵ 
//		//HWAVEOUT  Ѵ
//		pMainWnd->m_hWaveOut = (HWAVEOUT)wParam;
//		TCHAR str[200];
//		_stprintf(str, _T("0x%8x"), pMainWnd->m_hWaveOut);
//		MessageBox(pMainWnd->m_hwndCB, str, str, MB_OK);
//		break;
//	//kayws426{{
//	case WM_CLOSE:
//		TRACE(L"WM_CLOSE\r\n");
//		if( GetActiveWindow()!=pMainWnd->m_hWnd ) {
//			TRACE(L"WM_CLOSE message => !Active Window \r\n");
//			ShowWindow(pMainWnd->m_hWnd, SW_MINIMIZE);
//			//PostMessage(pMainWnd->m_hWnd, WM_SHOWWINDOW, SW_MINIMIZE, 0);
//			return 0;
//		}
//		break;
//	//kayws426}}
//	}
//	return __super::PpcMainWndProc(hwnd, uMsg, wParam, lParam);
//}

//void CKayWin32MainWnd::OnInitMenuPopup(HMENU hMenu, UINT uPos, BOOL fSystemMenu)
//{
//	TRACE0("CKayWin32MainWnd::OnInitMenuPopup\n");
//	if (uPos==IDM_TOOL) {
//		BOOL bLoaded = m_pLyricWnd && m_pLyricWnd->IsLyricLoaded();
//		DWORD dwFlag = (bLoaded) ? (MF_ENABLED) : (MF_GRAYED);
//		//EnableMenuItem(hMenu, IDM_LYRIC_SHOWHIDE, dwFlag);
//		EnableMenuItem(hMenu, IDM_LYRIC_SYNC_PULL, dwFlag);
//		EnableMenuItem(hMenu, IDM_LYRIC_SYNC_PUSH, dwFlag);
//		EnableMenuItem(hMenu, IDM_LYRIC_SYNC_RESET, dwFlag);
//		CheckMenuItem(hMenu, IDM_LYRIC_SHOWHIDE, (m_bAutoShowLyricWnd)?MF_CHECKED:MF_UNCHECKED);
//	}
//	__super::OnInitMenuPopup(hMenu, uPos, fSystemMenu);
//}

static const UINT s_kay_uHoldKeys[][2] = {
	{VK_RETURN, 0}, {VK_LEFT, 0},
	{VK_UP, 0}, {VK_RIGHT, 0}, {VK_DOWN, 0},
//	{VK_BTN1, MOD_WIN}, {VK_BTN2, MOD_WIN},
//	{VK_BTN3, MOD_WIN}, {VK_BTN4, MOD_WIN},
//	{VK_BTN5, MOD_WIN}, {VK_BTN6, MOD_WIN}, 
};

//void CKayWin32MainWnd::ProcessHotKey(int nId, UINT fuModifiers, UINT uVirtKey, unsigned short keyMode)
//{
//	// WM_HOTKEY폜
//	MSG msg;
//	while (PeekMessage(&msg, m_hWnd, WM_HOTKEY, WM_HOTKEY, PM_REMOVE));
//
//	CWin32Options* pOptions = (CWin32Options*)m_pOptions;
//	if (!pOptions) return;
//
//	// o?QƂ
//	for (int i = 0; i < pOptions->m_listKeyMap.GetCount(); i++) {
//		ACCEL* p = (ACCEL*)pOptions->m_listKeyMap.GetAt(i);
//
//		if (keyMode == 1) { // double click
//			if (p->pad != 1) {
//				continue;
//			}
//		} else {
//			if (p->pad == 1) {
//				continue;
//			}
//		}
//		if (p->key == uVirtKey) {
//			// ???CAO?Ăꍇ
//			// ?CAÓAj?ôȂ
//			if (m_fMenuLoop || m_hMenu || (GetWindowLong(m_hWnd, GWL_STYLE) & WS_DISABLED)) {
//				switch (p->cmd) {
//				case IDM_PLAY_PLAYPAUSE:
//				case IDM_PLAY_STOP:
//				case IDM_PLAY_PREV:
//				case IDM_PLAY_REW:
//				case IDM_PLAY_FF:
//				case IDM_PLAY_NEXT:
//				case IDM_PLAY_REPEAT:
//				case IDM_TOOL_VOLUP:
//				case IDM_TOOL_VOLDOWN:
//				case IDM_TOOL_TOGGLEDISPLAY:
//				case IDM_TOOL_HOLD:
//				case IDM_TOOL_HOLDDISP:
//				case IDM_PLAY_PLAYSTOP:
//				case IDM_PLAY_NEXT_FOLDER:
//				case IDM_PLAY_PREV_FOLDER:
//					break;
//				default: return;
//				}
//			}
//
//			if (m_fHold) {
//				BOOL fHold = FALSE;
//				ACCEL* p = (ACCEL*)pOptions->m_listKeyMap.GetAt(i);
//				for (int j = 0; j < sizeof(s_kay_uHoldKeys) / sizeof(UINT) / 2; j++) {
//					if (s_kay_uHoldKeys[j][0] == p->key) {
//						fHold = TRUE;
//						break;
//					}
//				}
//
//				if (p->cmd == IDM_TOOL_TOGGLEDISPLAY ||
//					p->cmd == IDM_TOOL_HOLD ||
//					p->cmd == IDM_TOOL_HOLDDISP || !fHold)
//					PostMessage(m_hWnd, WM_COMMAND, p->cmd, 0);
//				else {
//					KillTimer(m_hWnd, ID_TIMER_HOLD);
//					m_fDrawHold = TRUE;
//					SetTimer(m_hWnd, ID_TIMER_HOLD, TIMER_HOLD_INTERVAL, NULL);
//					UpdateTitle();
//				}
//			}
//			else PostMessage(m_hWnd, WM_COMMAND, p->cmd, 0);
//
//			// obNCgȊO
//			// obNCgON䂪L̂Ƃ
//			if (pOptions->m_fDispAutoOn &&
//				(p->cmd != IDM_TOOL_TOGGLEDISPLAY && p->cmd != IDM_TOOL_HOLDDISP)) {
//				TurnOnDisplay();
//				m_fDisplay = TRUE;
//
//				InvalidateRect(m_hWnd, NULL, TRUE);
//				UpdateWindow(m_hWnd);
//			}
//			return;
//		}
//	}
//
//	if (m_fHold) {
//		KillTimer(m_hWnd, ID_TIMER_HOLD);
//		m_fDrawHold = TRUE;
//		SetTimer(m_hWnd, ID_TIMER_HOLD, TIMER_HOLD_INTERVAL, NULL);
//		UpdateTitle();
//	}
//
//	if (keyMode == 1) {
//		ProcessHotKey(nId, fuModifiers, uVirtKey, 0);
//		ProcessHotKey(nId, fuModifiers, uVirtKey, 0);
//	}
//
//}

//void CKayWin32MainWnd::OnHotKey(int nId, UINT fuModifiers, UINT uVirtKey)
//{
//	if (fuModifiers & MOD_KEYUP) {
//		if (m_ClickInfo.state == 0) {
//			m_ClickInfo.state = 1;
//			SetTimer(m_hWnd, ID_TIMER_CLICKCHECK, TIMER_CLICKCHECK_INTERVAL, NULL);
//			m_ClickInfo.nID = nId;
//			m_ClickInfo.modifiers = fuModifiers;
//			m_ClickInfo.virtKey = uVirtKey;
//			return;
//		} else {
//			KillTimer(m_hWnd, ID_TIMER_CLICKCHECK);
//			m_ClickInfo.state = 0;
//			ProcessHotKey(m_ClickInfo.nID, m_ClickInfo.modifiers, m_ClickInfo.virtKey, true);
//		}
//
//	} else {
//		//::MessageBox(m_hWnd, _T("down"), _T("down"), MB_OK);
//		return;
//	}
//
//}

//void CKayWin32MainWnd::RegisterHotKeys()
//{
//	if (m_fHotKey)
//		return;
//
//	int i, j;
//	if (m_fHold) {
//		for (i = 0; i < sizeof(s_kay_uHoldKeys) / sizeof(UINT) / 2; i++)
//			RegisterHotKey(m_hWnd, s_kay_uHoldKeys[i][0], s_kay_uHoldKeys[i][1]|MOD_KEYUP, s_kay_uHoldKeys[i][0]);
//
//		CPpcOptions* pOptions = (CPpcOptions*)m_pOptions;
//		for (i = 0; i < pOptions->m_listKeyMap.GetCount(); i++) {
//			BOOL fHold = FALSE;
//			ACCEL* p = (ACCEL*)pOptions->m_listKeyMap.GetAt(i);
//			for (j = 0; j < sizeof(s_kay_uHoldKeys) / sizeof(UINT) / 2; j++) {
//				if (s_kay_uHoldKeys[j][0] == p->key) {
//					fHold = TRUE;
//					break;
//				}
//			}
//			
//			if (!fHold) {
//				UINT fsModifiers = 0;
//				if (p->fVirt & FALT)
//					fsModifiers |= MOD_ALT;
//				if (p->fVirt & FCONTROL)
//					fsModifiers |= MOD_CONTROL;
//				if (p->fVirt & FSHIFT)
//					fsModifiers |= MOD_SHIFT;
//				if (p->fVirt & FWIN)
//					fsModifiers |= MOD_WIN;
//				RegisterHotKey(m_hWnd, p->key, fsModifiers|MOD_KEYUP, p->key);
//			}
//		}
//	}
//	else {
//		CPpcOptions* pOptions = (CPpcOptions*)m_pOptions;
//		for (i = 0; i < pOptions->m_listKeyMap.GetCount(); i++) {
//			ACCEL* p = (ACCEL*)pOptions->m_listKeyMap.GetAt(i);
//
//			UINT fsModifiers = 0;
//			if (p->fVirt & FALT)
//				fsModifiers |= MOD_ALT;
//			if (p->fVirt & FCONTROL)
//				fsModifiers |= MOD_CONTROL;
//			if (p->fVirt & FSHIFT)
//				fsModifiers |= MOD_SHIFT;
//			if (p->fVirt & FWIN)
//				fsModifiers |= MOD_WIN;
//			RegisterHotKey(m_hWnd, p->key, fsModifiers|MOD_KEYUP, p->key);
//		}
//	}
//	m_fHotKey = TRUE;
//}
