#ifndef __KAYPPCMAINWND_H__
#define __KAYPPCMAINWND_H__

#include "PpcMainWnd.h"
#include "KayLyricWnd.h"


#define		ID_TIMER_CLICKCHECK			(ID_TIMER_HOLD+1)
#define		TIMER_CLICKCHECK_INTERVAL	300


class CKayPpcMainWnd : public CPpcMainWnd
{
	friend CKayLyricWnd;
public:
	CKayPpcMainWnd();
	virtual ~CKayPpcMainWnd();

public:
	virtual HACCEL GetAccelHandle();

protected: //overrides
//	virtual COptions* GetOptionsClass();
	virtual void OnCreate(HWND hWnd);
	virtual void OnClose();
	virtual void OnSize(UINT nType, int cx, int cy);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void OnToolOption();
//	virtual void OnInitMenuPopup(HMENU hMenu, UINT uPos, BOOL fSystemMenu);

	static LRESULT CALLBACK KayPpcMainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

protected: //overrides
	virtual void RegisterClass();
	virtual BOOL Open(int nIndex);
	virtual BOOL Play(int nIndex = OPEN_NONE);
	virtual void Stop();
	virtual void OnTimer(UINT uID);
	virtual void ProcessHotKey(int nId, UINT fuModifiers, UINT uVirtKey, unsigned short keyMode);
	virtual void OnHotKey(int nId, UINT fuModifiers, UINT uVirtKey);

protected: //overrides
	virtual void CreateListView();
	virtual void RegisterHotKeys();

protected:
	virtual void UpdateListImage(int nIndex);

	CKayLyricWnd* m_pLyricWnd;
	HWAVEOUT m_hWaveOut;
	HIMAGELIST m_hImageListPlayList;

	class CMainClickInfo {
	public:
		int state; // 0: not clicked , 1: clicked
		int nID;
		UINT modifiers;
		UINT virtKey;

		CMainClickInfo() : state(0), nID(0), modifiers(0), virtKey(0) {}
	};
	CMainClickInfo m_ClickInfo;

};

#endif // __KAYPPCMAINWND_H__