#include "GSPlayer2.h"
#include "KayMainWnd.h"
//#include "../PPC_KayPlayer/resource.h"
#include <assert.h>

#ifdef _WIN32_WCE_PPC
# include <winsock2.h>
#else
#  include <assert.h>
#  define ASSERT assert
#endif

CKayMainWnd::CKayMainWnd()
{
	m_fVolMuted = FALSE;
	RepeatLoopReset();
}

CKayMainWnd::~CKayMainWnd()
{
}

void CKayMainWnd::RepeatLoopReset(BOOL fDisplay /*= FALSE*/)
{
//	if(m_hWnd && IsWindow(m_hWnd)) {
//		KillTimer(m_hWnd, ID_TIMER_REPEAT_LOOP);
//		if(fDisplay)
//			SetTimer(m_hWnd, ID_TIMER_REPEAT_LOOP, TIMER_REPEAT_LOOP_INTERVAL, NULL);
//	}
	m_fDrawRepeatLoop = fDisplay;
	m_nRepeatLoopState = 0;
	m_lRepeatLoopStart = -1;
	m_lRepeatLoopEnd = -1;
	m_lRepeatLoop_A = -1;
	m_lRepeatLoop_B = -1;
}

//void CKayMainWnd::OnCreate(HWND hWnd)
//{
//	CMainWnd::OnCreate(hWnd);
//	ChangeTitle(_T("KayPlayer"));
//}

LRESULT CKayMainWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)) {
		case IDM_APP_EXIT:
			PostMessage(m_hWnd, WM_CLOSE, 0, 0);
			return 0;
		case IDM_TOOL_VOLMUTE:
			OnVolumeMute();
			return 0;
		case IDM_PLAY_NEXT_FOLDER:
			OnPlayNextFolder();
			return 0;
		case IDM_PLAY_PREV_FOLDER:
			OnPlayPrevFolder();
			return 0;
		case IDM_REPEAT_LOOP:
		case IDM_REPEAT_LOOP_CLEAR:
		case IDM_REPEAT_LOOP_SET_START:
		case IDM_REPEAT_LOOP_SET_END:
			OnRepeatLoop(LOWORD(wParam));
			return 0;
	}
	return CMainWnd::OnCommand(wParam, lParam);
}


void CKayMainWnd::OnVolumeMute()
{
	m_fVolMuted = !m_fVolMuted;
	InitVolume();
	m_fDrawVolume = TRUE;
	UpdateTitle();
}

void CKayMainWnd::OnToolOption()
{
	CMainWnd::OnToolOption();
	InitVolume();
}

BOOL CKayMainWnd::MyConnectServer(LPCTSTR pszURL, LPTSTR pszRedirect)
{
#define RECV_INTERVAL         1000000
#define RECV_CONNECT_TIMEOUT 15000000
#define RECV_RECEIVE_TIMEOUT  5000000
#define RECV_HTTP 80
#define RECV_BUFF_SIZE 2048
#define ICY_REDIRECT 302
#define ICY_OK 200
	BOOL bEof = FALSE;
	BOOL bFound_M3U_header = FALSE;

	int nPort, nLen = 0, nRet = 0, nTimeout = 0;
	unsigned long addr, val = 1;
	struct sockaddr_in sAddr;
	struct hostent* pHost;
	char* psz;
	char szURL[MAX_URL];
//	char szProxy[MAX_URL];
	char szHostName[MAX_URL] = {0};
	char szUserAgent[MAX_URL] = "GSPlayer2";
	char szRequest[MAX_URL * 4];
	char szRecv[RECV_BUFF_SIZE];
	fd_set	fdRecv, fdError;
	struct timeval tv = {0, RECV_INTERVAL};

	*pszRedirect = NULL;
	WideCharToMultiByte(CP_ACP, 0, pszURL, -1, szURL, MAX_URL, 0, 0);
	if (!strlen(szURL))
		return FALSE;

	// URL͂
	// ProxyT?o?ݒ肳ĂƂ̓T?o?AhX
	if (strncmp(szURL, "http://", strlen("http://"))) {
		if (sscanf(szURL, "%[^:/]:%d", szHostName, &nPort) < 2)
			nPort = RECV_HTTP;
		psz = strchr(szURL, '/');
	}
	else {
		if (sscanf(szURL, "http://%[^:/]:%d", szHostName, &nPort) < 2)
			nPort = RECV_HTTP;
		psz = strchr(szURL + 7, '/');
	}
	if (!strlen(szHostName))
		return FALSE;

	// socket̍쐬
	SOCKET hSock = socket(PF_INET, SOCK_STREAM, 0);
	if (hSock == INVALID_SOCKET)
		return FALSE;

	// AhX̎擾
	addr = inet_addr(szHostName);
	if (addr == SOCKET_ERROR) {
		pHost = gethostbyname(szHostName);
		if (!pHost)
			return FALSE;
		addr = *((unsigned long*)(pHost->h_addr_list)[0]);
	}

	// 񓯊Mɐ؂ւ
	if (ioctlsocket(hSock, FIONBIO, &val) == SOCKET_ERROR)
		goto fail;

	// ڑ
	memset(&sAddr, 0, sizeof(struct sockaddr_in));
	sAddr.sin_family = AF_INET;
	sAddr.sin_port = htons((u_short)nPort);
	sAddr.sin_addr.s_addr = addr;
	connect(hSock, (const sockaddr*)&sAddr, sizeof(sAddr));

	// ?C?AEg܂ő҂
	nTimeout = 0;
	while (TRUE) {
		FD_ZERO(&fdRecv);
		FD_SET(hSock, &fdRecv);
		FD_ZERO(&fdError);
		FD_SET(hSock, &fdError);
		if (select(NULL, 0, &fdRecv, &fdError, &tv) != SOCKET_ERROR) {
			if (FD_ISSET(hSock, &fdError))
				goto fail;
			else if (FD_ISSET(hSock, &fdRecv))
				break;
		}

		nTimeout += RECV_INTERVAL;
		if (nTimeout > RECV_CONNECT_TIMEOUT)
			goto fail;
	}

	// Request(HTTP)̑M
	sprintf(szRequest, "GET %s HTTP/1.0\r\nHost: %s\r\nAccept: */*\r\nIcy-MetaData:1\r\nUser-Agent: %s\r\n\r\n",
	psz ? psz : "/", szHostName, szUserAgent);
	//x-audiocast-udpport: %d\r\n ܂Ή

	if (send(hSock, szRequest, strlen(szRequest), 0) == SOCKET_ERROR)
		goto fail;

	// ICY (HTTP)wb?ׂĎM
	psz = NULL;
	while (!psz && RECV_BUFF_SIZE - nLen - 1 > 0) {
		// ?C?AEg܂ő҂
		nTimeout = 0;
		while (TRUE) {
			FD_ZERO(&fdRecv);
			FD_SET(hSock, &fdRecv);
			if (select(NULL, &fdRecv, 0, 0, &tv) != SOCKET_ERROR && FD_ISSET(hSock, &fdRecv))
				break;

			nTimeout += RECV_INTERVAL;
			if (nTimeout > RECV_RECEIVE_TIMEOUT)
				goto fail;
		}

		int nRecv = recv(hSock, szRecv + nLen, RECV_BUFF_SIZE - nLen, 0);
		if (!nRecv || nRecv == SOCKET_ERROR)
			goto fail;

		nLen += nRecv;
		if (nRet == 0) {
			// G?R?h?FbN
			if (!sscanf(szRecv, " %*s %d", &nRet))
				goto fail;

			if (nRet != ICY_OK && nRet != ICY_REDIRECT)
				goto fail;
		}

		szRecv[nLen] = NULL;
		psz = strstr(szRecv, "\r\n\r\n");
	}

	if (!psz)	// wb?IĂȂ
		goto fail;

	// wb?͂
	if (nRet == ICY_REDIRECT) {
		// ?CNg
		{//DisconnectServer:
			if (hSock != INVALID_SOCKET) {
				shutdown(hSock, -2);
				closesocket(hSock);
				hSock = INVALID_SOCKET;
			}
		}

		psz = strstr(szRecv, "Location: ");
		if (sscanf(psz, "Location: %256[^\r\n]", szURL) == 1) {
#ifdef _UNICODE
			MultiByteToWideChar(CP_ACP, 0, szURL, -1, pszRedirect, MAX_URL);
#else
			strncpy(pszRedirect, szURL, MAX_URL);
			pszRedirect[MAX_URL - 1] = NULL;
#endif
			return FALSE;
		}
	}

	// skip Headers
	int nRecv;
	psz = strstr(szRecv, "\r\n\r\n");
	if(psz) {
		psz += 4;
		nLen -= psz - szRecv;
		if(nLen>0) {
			memmove(szRecv, psz, nLen);
			szRecv[nLen] = NULL;
		}
	}

	//fill buffer
//	Sleep(200);//XXX
//	nRecv = recv(hSock, szRecv + nLen, RECV_BUFF_SIZE - nLen, 0);
//	if (nRecv == SOCKET_ERROR) goto fail;
//	if (nRecv == 0) bEof = TRUE;
//	nLen += nRecv;

	// find m3u
	char *psz2, *psz3, *psz4;

	while(psz && nLen > 0 && psz < szRecv + nLen) {
		nLen -= psz - szRecv;
		if(nLen>0) {
			memmove(szRecv, psz, nLen);
			szRecv[nLen] = NULL;
		}
		psz = szRecv;

		//Eof  ƴϰ ִ¹ ũ(RECV_BUFF_SIZE-nLen) 0 Ŭ ޴´.
		if(!bEof && (RECV_BUFF_SIZE-nLen)>0 ) {
			{//Ÿ ƿ 
				nTimeout = 0;
				while (TRUE) {
					FD_ZERO(&fdRecv);
					FD_SET(hSock, &fdRecv);
					if (select(NULL, &fdRecv, 0, 0, &tv) != SOCKET_ERROR && FD_ISSET(hSock, &fdRecv))
						break;

					nTimeout += RECV_INTERVAL;
					if (nTimeout > RECV_RECEIVE_TIMEOUT)
						goto fail;
				}
			}
			nRecv = recv(hSock, szRecv + nLen, RECV_BUFF_SIZE - nLen, 0);
			if (nRecv == SOCKET_ERROR) goto fail;
			if (nRecv == 0) bEof = TRUE;
			nLen += nRecv;
			szRecv[nLen] = NULL;
		}

#ifdef _UNICODE
		TCHAR wszTitle[MAX_PATH];
		TCHAR wszFile[MAX_PATH];
#endif
		char* pTitle;
		char szTitle[MAX_PATH];
		char szFile[MAX_PATH];
		int inf;

		// ޾Ҵ ȮѴ.
		psz2 = strchr(szRecv, '\r');
		psz3 = strchr(szRecv, '\n');
		psz4 = max(psz2, psz3);
		//Eof ƴϸ鼭    ޾ ٽ ޴´.
		if(!psz4 && !bEof)
			continue;
		//,  ̻ ְų.. ͸  ߴ.


		if(!bFound_M3U_header) {
			char* pszHeader = strstr(szRecv, "#EXTM3U");
			if(pszHeader) {
				bFound_M3U_header = TRUE;
			}
		}

		if(bFound_M3U_header) {
			if(psz[0]=='#') {
				if( 2==sscanf(psz, "#EXTINF:%d,%256[^\r\n]s", &inf, &szTitle) ) {
					pTitle = szTitle;
				}
				else {
					pTitle = NULL;
				}
			}
			else if( sscanf(psz, "%256[^\r\n]s", &szFile) ) {
				//Ͽ ߰
#ifdef _UNICODE
				MultiByteToWideChar(CP_ACP, 0, szFile, -1, wszFile, MAX_PATH);
				if(pTitle) {
					MultiByteToWideChar(CP_ACP, 0, pTitle, -1, wszTitle, MAX_PATH);
					AddFile(wszFile, wszTitle);
				}
				else {//pTitle==NULL
					AddFile(wszFile, NULL);
#else
					AddFile(szFile, pTitle);
#endif
				}
				pTitle = NULL;

			}
		}
		//ٷ..
		psz = psz4;
		if(psz) ++psz;
	}

fail:
	{//DisconnectServer2:
		if (hSock != INVALID_SOCKET) {
			shutdown(hSock, -2);
			closesocket(hSock);
			hSock = INVALID_SOCKET;
		}
	}
	return bFound_M3U_header;
}

void CKayMainWnd::OnFileOpenLocation()
{
	TCHAR szLocation[MAX_URL];
	BOOL bAdd = TRUE;//kayws426
	if (m_pOptions->ShowLocationDlg(m_hWnd, szLocation, &bAdd) == IDOK) {
		//kayws426{{
		if(!bAdd)
			DeleteAllFile();
		//kayws426}}
		//kayws426{{
		check:
		BOOL bSkip = FALSE;
		int nTry = 3;
		if(szLocation && nTry--) {
			TCHAR* pszExt = _tcsrchr(szLocation, _T('.'));
			if(pszExt) {
				if( _tcsnicmp(pszExt, _T(".mp3"), _tcslen(_T(".mp3"))) ) {
					TCHAR szRedirect[MAX_URL];
					while( !MyConnectServer(szLocation, szRedirect) ) {
						if (!_tcslen(szRedirect))
							break;
						_tcscpy(szLocation, szRedirect);
						goto check;
					}
					bSkip = TRUE;
				}
			}
		}
		//kayws426}}
		if(!bSkip)
			AddFile(szLocation);
		if (m_pListFile->GetCount())
			//OpenFirstFile();
			Play();

		if (m_pPlayListDlg)
			m_pPlayListDlg->UpdatePlayList();
	}
}

void RemoveReturn2(LPTSTR psz)
{
	// ̍Ō'\n'폜
	LPTSTR p = psz + _tcslen(psz) - 1;
	if (*p == '\n') *p = NULL;

	// ̍Ō' '폜
	//kayws426: 
	while ( _T(' ') == *(p-1) )
		--p;
	*p = NULL;
}

void CKayMainWnd::LoadM3uPlayList(LPTSTR pszFile)
{
	TCHAR szBuff[MAX_PATH * 2];
	TCHAR szTitle[MAX_PATH] = {0};
	FILE* fp = _tfopen(pszFile, _T("r"));
	if (!fp) return;

	TCHAR szPath[MAX_PATH];
	_tcscpy(szPath, pszFile);
	LPTSTR psz = _tcsrchr(szPath, _T('\\'));
	if (psz) *psz = NULL;

#define EXTINF	_T("#EXTINF")
	while (_fgetts(szBuff, MAX_PATH * 2, fp)) {
		RemoveReturn2(szBuff);
		if (szBuff[0] == '#') {
			if (_tcsncmp(szBuff, EXTINF, _tcslen(EXTINF)) == 0) {
				LPTSTR p = _tcschr(szBuff, ',');
				if (p++) {
					while (*p == ' ') p++;
					if (_tcslen(p)) {
						_tcsncpy(szTitle, p, MAX_PATH);
						szTitle[MAX_PATH - 1] = NULL;
					}
				}
			}
			continue;
		}

		if (!_tcslen(szBuff))
			continue;
		AddFile2(szPath, szBuff, _tcslen(szTitle) ? szTitle : NULL);
		szTitle[0] = NULL;
	}
	fclose(fp);
}

void CKayMainWnd::SaveM3uPlayList(LPTSTR pszFile)
{
	// M3Ǔ`
	// #EXTM3U
	// #EXTINF:<t(b)>,<^Cg>
	// <t@C̃pX>
	// ...

	FILE* fp = _tfopen(pszFile, _T("w"));
	if (!fp) return;

	TCHAR szPath[MAX_PATH];
	_tcscpy(szPath, pszFile);
	LPTSTR psz = _tcsrchr(szPath, _T('\\'));
	if (psz) *(psz + 1) = NULL;

	// wb_Lq
	_ftprintf(fp, _T("#EXTM3U\n"));

	// XgLq
	for (int i = 0; i < m_pListFile->GetCount(); i++) {
		FILEINFO* p = (FILEINFO*)m_pListFile->GetAt(i);
		if (p) {
			TCHAR szTitle[MAX_PATH];
			GetTitle(i, szTitle);
			// #EXTINF:<t(b)>,<^Cg>
			_ftprintf(fp, _T("#EXTINF:%d"),
				p->info.nDuration == 0 ? -1 : p->info.nDuration / 1000);
			_ftprintf(fp, _T(",%s\n"), szTitle);

			// <t@C̃pX>
			if (_tcsncmp(szPath, p->szPath, _tcslen(szPath)) == 0)
				_ftprintf(fp, _T("%s\n"), p->szPath + _tcslen(szPath)); // ΃pX
			else
				_ftprintf(fp, _T("%s\n"), p->szPath); // ΃pX
		}
	}
	fclose(fp);
}

void CKayMainWnd::OnPlayRepeat()
{
	// ٲٱ  override
	switch (m_pOptions->m_fRepeat) {
	case COptions::RepeatNone:
		m_pOptions->m_fRepeat = COptions::RepeatOne;
		break;
	case COptions::RepeatOne:
		m_pOptions->m_fRepeat = COptions::RepeatAll;
		break;
	default:
		m_pOptions->m_fRepeat = COptions::RepeatNone;
		break;
	}
	UpdatePlayOption();
}

void CKayMainWnd::ChangeTitle(LPTSTR str)
{
	if( IsWindow(m_hWnd) )
		SetWindowText(m_hWnd, str);
}

void CKayMainWnd::InitVolume()
{
	if(m_fVolMuted) {
		MAP_SetVolume(m_hMap, 0);//Mute Volume
	}
	else if(m_pOptions->m_fUseSystemVolume) {
		MAP_SetVolume(m_hMap, (DWORD)-1);//MAX Volume
	}
	else {
		MAP_SetVolume(m_hMap, m_dwCurrentSoftVolume);
	}
}

BOOL CKayMainWnd::Open(int nIndex)
{
	InitVolume();
	RepeatLoopReset();

	return CMainWnd::Open(nIndex);
}

MMRESULT CKayMainWnd::waveOutGetVolume(HWAVEOUT hwo, LPDWORD pdwVolume)
{
	MMRESULT res = MMSYSERR_NOERROR;
	if(m_pOptions->m_fUseSystemVolume) {
		res = ::waveOutGetVolume(NULL, pdwVolume);
	} else {
		*pdwVolume = m_dwCurrentSoftVolume;
	}
	return res;
}

MMRESULT CKayMainWnd::waveOutSetVolume(HWAVEOUT hwo, DWORD dwVolume)
{
	MMRESULT res = MMSYSERR_NOERROR;
	m_dwCurrentVolume = dwVolume;

	//  ̹ Ʈ ´.
	//

	//  ý  Ʈ Ѵ
	if(m_pOptions->m_fUseSystemVolume) {
		res = ::waveOutSetVolume(NULL, dwVolume);
	}
	else {//Ʈ  ΰ
		m_dwCurrentSoftVolume = dwVolume;
		// 尡 ƴҶ Ѵ.
		if(!m_fVolMuted) {
			MAP_SetVolume(m_hMap, dwVolume);
		}
	}
	return res;
}

void CKayMainWnd::OnTimer(UINT uID)
{
	if (uID == ID_TIMER_TIME) {
		if( (m_nRepeatLoopState&0x03) == 0x03 ) {
			long current = MAP_GetCurrent(m_hMap);
			if (current >= m_lRepeatLoopEnd && m_lRepeatLoopEnd!=-1 && m_lRepeatLoopStart!=-1) {
				MAP_Seek(m_hMap, m_lRepeatLoopStart);
			}
		}

		UpdateTime();
	}
	else if (uID == ID_TIMER_REPEAT_LOOP) {
		KillTimer(m_hWnd, ID_TIMER_REPEAT_LOOP);
		m_fDrawRepeatLoop = FALSE;
		UpdateTitle();
	}
	else if (uID == ID_TIMER_SCROLLTITLE) {
		if (++m_nTitleWait >=  SCROLL_TITLE_INITWAIT) {
			if (m_pOptions->m_fScrollTitle) {
				if (!m_fDrawVolume && !m_fDrawRepeatLoop) {
					if (m_nTitleLen - SCROLL_TITLE_MARGIN > m_nTitleWidth) {
						m_nTitlePos += SCROLL_TITLE_INTERVAL;
						UpdateTitle();
					}
				}
			}
		}
	}
	else
		CMainWnd::OnTimer(uID);
}

void CKayMainWnd::RegisterClass()
{
	WNDCLASS	wc;
	memset(&wc, 0, sizeof(WNDCLASS));
    wc.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
    wc.lpfnWndProc = (WNDPROC)KayMainWndProc;
    wc.hInstance = GetInst();
    wc.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
    wc.lpszClassName = MAINWND_CLASS_NAME;
	::RegisterClass(&wc);
}

LRESULT CALLBACK CKayMainWnd::KayMainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static CKayMainWnd* pMainWnd = NULL;

	switch (uMsg) {
	case WM_CREATE:
		CREATESTRUCT* pcs;
		pcs = (CREATESTRUCT*)lParam;
		pMainWnd = (CKayMainWnd*)pcs->lpCreateParams;
		return CMainWnd::MainWndProc(hwnd, uMsg, wParam, lParam);
	case WM_INITMENUPOPUP:
		pMainWnd->CKayMainWnd::OnInitMenuPopup((HMENU)wParam, LOWORD(lParam), HIWORD(lParam));//!!
		return CMainWnd::MainWndProc(hwnd, uMsg, wParam, lParam);
	}
	return CMainWnd::MainWndProc(hwnd, uMsg, wParam, lParam);
}

void CKayMainWnd::DrawTitle(HDC hDC)
{
	if (m_fDrawRepeatLoop) {
		DrawRepeatLoop(hDC);
		return;
	}
	else
		CMainWnd::DrawTitle(hDC);
}

void CKayMainWnd::DrawRepeatLoop(HDC hDC)
{
	SIZE size;
	TCHAR szTitle[MAX_PATH] = {0};
	RECT rc = {TITLE_LEFT, m_nTitleTop,
			TITLE_LEFT + m_nTitleWidth, m_nTitleTop + m_nTitleHeight};

	CTempStr str;

	if( (m_nRepeatLoopState&0x03) == 0x01 ) {
		str.LoadNormal(IDM_REPEAT_LOOP_SET_A);
	} else if( (m_nRepeatLoopState&0x03) == 0x02 ) {
		str.LoadNormal(IDM_REPEAT_LOOP_SET_B);
	} else if( (m_nRepeatLoopState&0x03) == 0x03 ) {
		str.LoadNormal(IDM_REPEAT_LOOP_PLAY);
	} else if( (m_nRepeatLoopState&0x03) == 0x00 ) {
		str.LoadNormal(IDM_REPEAT_LOOP_SET_CLEAR);
	}

	_tcscpy(szTitle, str);

	COLORREF crBk = SetTextColor(hDC, m_pSkin->GetColor(COLOR_TITLE));
	int nOld = SetBkMode(hDC, TRANSPARENT);
	HFONT hBk = (HFONT)SelectObject(hDC, m_hFntTitle);
	GetTextExtentPoint32(hDC, szTitle, _tcslen(szTitle), &size);
	DrawText(hDC, szTitle, -1, &rc, DT_LEFT | DT_BOTTOM | DT_SINGLELINE | DT_NOPREFIX);
	SetTextColor(hDC, crBk);
	SetBkMode(hDC, nOld);
	SelectObject(hDC, hBk);
}

void CKayMainWnd::OnPlayNextFolder()
{
	int nNext = GetNextFolderIndex();
	if (nNext == OPEN_NONE)
		return;

	BOOL fPlay = MAP_GetStatus(m_hMap) != MAP_STATUS_STOP;
	Open(nNext);
	if (fPlay)
		Play();
}

void CKayMainWnd::OnPlayPrevFolder()
{
	BOOL fPlay = MAP_GetStatus(m_hMap) != MAP_STATUS_STOP;

	int nPrev = GetPrevFolderIndex();
	if (nPrev == OPEN_NONE)
		return;

	Open(nPrev);
	if (fPlay)
		Play();
}

void CKayMainWnd::OnRepeatLoop(int iMenu)
{
//preJop:
	if(MAP_GetStatus(m_hMap)!=MAP_STATUS_PLAY)
		iMenu = -1;// ޴ --> 
	else
	if(IDM_REPEAT_LOOP == iMenu) {
		if( (m_nRepeatLoopState&0x01) == 0 ) {//A  ȵ 
			// ݺ  A
			iMenu = IDM_REPEAT_LOOP_SET_A;
		}
		else if( (m_nRepeatLoopState&0x02) == 0 ) {//B  ȵ 
			// ݺ  B
			iMenu = IDM_REPEAT_LOOP_SET_B;
		}
		else if( (m_nRepeatLoopState&0x03) == 0x03 ) {
			// ݺ  
			iMenu = IDM_REPEAT_LOOP_SET_CLEAR;
		}
	}
//mainJop:
	BOOL fDataChenged = FALSE;
	LONG lCurr = -1;
	switch(iMenu) {
	case IDM_REPEAT_LOOP_SET_A:
		{
			// ݺ  A -   ==>  
			m_nRepeatLoopState |= 0x01;
			m_fDrawRepeatLoop = TRUE;
			lCurr = m_lRepeatLoop_A = MAP_GetCurrent(m_hMap);
			fDataChenged = TRUE;
			break;
		}
	case IDM_REPEAT_LOOP_SET_B:
		{
			// ݺ  B -   ==>  
			m_nRepeatLoopState |= 0x02;
			m_fDrawRepeatLoop = TRUE;
			lCurr = m_lRepeatLoop_B = MAP_GetCurrent(m_hMap);
			fDataChenged = TRUE;
			break;
		}
	case IDM_REPEAT_LOOP_SET_CLEAR:
		{
			// ݺ   -  
			RepeatLoopReset(TRUE);
			break;
		}
	default:
		{
			// ݺ  
			RepeatLoopReset();
		}
	}

	if( (m_nRepeatLoopState&0x03) == 0x03 ) {
		// ݺ ƴϸ    Ƿ...
		if(fDataChenged) {
			//A  B  ٲǷ Start  End  Ѵ.
			if(m_lRepeatLoop_A<m_lRepeatLoop_B) {
				m_lRepeatLoopStart = m_lRepeatLoop_A;
				m_lRepeatLoopEnd   = m_lRepeatLoop_B;
			}
			else {
				m_lRepeatLoopStart = m_lRepeatLoop_B;
				m_lRepeatLoopEnd   = m_lRepeatLoop_A;
			}
		}

		//always Start <= End
		ASSERT(m_lRepeatLoopStart<m_lRepeatLoopEnd);
		//  ̸ ʳ .
		if(lCurr>=m_lRepeatLoopEnd)
			MAP_Seek(m_hMap, m_lRepeatLoopStart);
	}

	KillTimer(m_hWnd, ID_TIMER_REPEAT_LOOP);
	UpdateTitle();
	if(m_fDrawRepeatLoop) {
		SetTimer(m_hWnd, ID_TIMER_REPEAT_LOOP, TIMER_REPEAT_LOOP_INTERVAL, NULL);
	}
}

void CKayMainWnd::OnInitMenuPopup(HMENU hMenu, UINT uPos, BOOL fSystemMenu)
{
#ifdef _WIN32_WCE_PPC
	TRACE0("CKayMainWnd::OnInitMenuPopup\n");
	if (uPos == IDM_PLAY) {
		CheckMenuItem(hMenu, IDM_REPEAT_LOOP_SET_A, ((m_nRepeatLoopState&0x01)==0x01)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_REPEAT_LOOP_SET_B, ((m_nRepeatLoopState&0x02)==0x02)?MF_CHECKED:MF_UNCHECKED);
	}
	else if (uPos == IDM_TOOL) {
		CheckMenuItem(hMenu, IDM_TOOL_VOLMUTE, m_fVolMuted?MF_CHECKED:MF_UNCHECKED);
	}
#endif
}

static
void GetPath(TCHAR szIn[MAX_PATH], TCHAR szOut[MAX_PATH])
{
	_tcscpy(szOut, szIn);
	unsigned short *ptr = wcsrchr(szOut, _T('\\'));
	*ptr = _T('\0');
}

int CKayMainWnd::GetNextFolderIndex()
{
	if (m_nCurrent == OPEN_NONE)
		return OPEN_NONE;

	int nMax = m_pListFile->GetCount() - 1;

	TCHAR szCurPath[MAX_PATH];
	{
		// Get Current File Path
		FILEINFO *info = GetInfo(m_nCurrent);
		GetPath(info->szPath, szCurPath);
	}

	for (int i=m_nCurrent+1; i <= nMax; i++) {
		if (i == nMax) {
			return 0;
		}
		FILEINFO *tmp_info = GetInfo(i);
		TCHAR szTmpPath[MAX_PATH];
		GetPath(tmp_info->szPath, szTmpPath);

		if (wcscmp(szCurPath, szTmpPath)==0) continue;
		return i;
	}
	return 0;
}

int CKayMainWnd::GetPrevFolderIndex()
{
	if (m_nCurrent == OPEN_NONE)
		return OPEN_NONE;

	TCHAR szCurPath[MAX_PATH];
	{
		// Get Current File Path
		FILEINFO *info = GetInfo(m_nCurrent);
		GetPath(info->szPath, szCurPath);
	}

	int count=0;
	for (int i=m_nCurrent-1; i >= 0; i--) {
		FILEINFO *tmp_info = GetInfo(i);
		TCHAR szTmpPath[MAX_PATH];
		GetPath(tmp_info->szPath, szTmpPath);

		if (wcscmp(szCurPath, szTmpPath)==0) {
			continue;
		} else {
			count++;
			if (count==2) {
				return i+1;
			}
			_tcscpy(szCurPath, szTmpPath);
		}
	}
	return 0;
}

BOOL CKayMainWnd::Play(int nIndex)
{
	m_nRepeatLoopState = 0;
	return CMainWnd::Play(nIndex);
}

void CKayMainWnd::Seek(int nMilisec)
{
	if( ((m_nRepeatLoopState&0x03)==0x03) && (nMilisec>m_lRepeatLoopEnd) ) {
		MAP_Seek(m_hMap, m_lRepeatLoopStart);
	}
	else {
		MAP_Seek(m_hMap, nMilisec);
	}
}

void CKayMainWnd::OnPlayRew()
{
	Seek((MAP_GetCurrent(m_hMap) - m_pOptions->m_dwSkipInterval/*SKIP_INTERVAL*/));
}

void CKayMainWnd::OnPlayFf()
{
	Seek((MAP_GetCurrent(m_hMap) + m_pOptions->m_dwSkipInterval/*SKIP_INTERVAL*/));
}

void CKayMainWnd::OnToolVolUp()
{
	m_fVolMuted = FALSE;
	InitVolume();
	CMainWnd::OnToolVolUp();
}

void CKayMainWnd::OnToolVolDown()
{
	m_fVolMuted = FALSE;
	InitVolume();
	CMainWnd::OnToolVolDown();
}

void CKayMainWnd::DrawVolume(HDC hDC)
{
	SIZE size;
	TCHAR szTitle[MAX_PATH] = {0};
	RECT rc = {TITLE_LEFT, m_nTitleTop,
			TITLE_LEFT + m_nTitleWidth, m_nTitleTop + m_nTitleHeight};

	DWORD dwVolume;
	waveOutGetVolume(NULL, &dwVolume);
	dwVolume = max(LOWORD(dwVolume), HIWORD(dwVolume));
	dwVolume = dwVolume * 100 / 0xFFFF;
	wsprintf(szTitle, CTempStr(m_fVolMuted?IDS_FMT_DISP_VOLMUTE:IDS_FMT_DISP_VOLUME), dwVolume);//kayws426

	COLORREF crBk = SetTextColor(hDC, m_pSkin->GetColor(COLOR_TITLE));
	int nOld = SetBkMode(hDC, TRANSPARENT);
	HFONT hBk = (HFONT)SelectObject(hDC, m_hFntTitle);
	GetTextExtentPoint32(hDC, szTitle, _tcslen(szTitle), &size);
	DrawText(hDC, szTitle, -1, &rc, DT_LEFT | DT_BOTTOM | DT_SINGLELINE | DT_NOPREFIX);
	SetTextColor(hDC, crBk);
	SetBkMode(hDC, nOld);
	SelectObject(hDC, hBk);

#ifdef _WIN32_WCE_PPC
#define VOLBAR_LEFT		80
#define VOLBAR_WIDTH	125
#define VOLBAR_HEIGHT	8
#else
#define VOLBAR_LEFT		50
#define VOLBAR_WIDTH	145
#define VOLBAR_HEIGHT	8
#endif
	if (!dwVolume)
		return;

	int nWidth = VOLBAR_WIDTH * dwVolume / 100;
	RECT rcBar = {TITLE_LEFT + VOLBAR_LEFT, m_nTitleTop + m_nTitleHeight - size.cy + 1,
				TITLE_LEFT + VOLBAR_LEFT + nWidth, m_nTitleTop + m_nTitleHeight};
	HBRUSH hbr = CreateSolidBrush(m_pSkin->GetColor(COLOR_TITLE));
	FillRect(hDC, &rcBar, hbr);
	DeleteObject(hbr);
}
