// LyricWnd.cpp: implementation of the CKayLyricWnd class.
//
//////////////////////////////////////////////////////////////////////

#include "GSPlayer2.h"
#include "MainWnd.h"
#include "KayMainWnd.h"
#include "KayOptions.h"
#ifdef _WIN32_WCE_PPC
#  include "PpcSkin.h"
#  include "KayPpcMainWnd.h"
#  include "KayPpcOptions.h"
#else
#  define PPC_PLAYLIST_LEFT  (GetSystemMetrics(SM_CXSCREEN)-302)
#  define PPC_PLAYLIST_TOP   (GetSystemMetrics(SM_CYSCREEN) - 26 * 2)
#  define PPC_PLAYLIST_WIDTH 300
#  include <assert.h>
#  define ASSERT assert
#endif
#include "KayLyricWnd.h"

//#define UNDER_NT
#include <wingdi.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define		TIMER_LYRIC_INTERVAL		333
#define		ID_TIMER_LYRIC				9

CKayLyricWnd::CKayLyricWnd()
{
	TRACE(_T("Welcome ! KayPlayer::CKayLyricWnd\n"));

	m_hWnd = NULL;
	m_pLyricList = NULL;
	m_fLyricDrag = FALSE;
	m_pszLyricInfo = NULL;
	m_pszAlbum = NULL;
	m_pszTitle = NULL;
	m_pszArtist = NULL;
	m_nDragItem = -1;
	SetDisplayLines(3);
	m_fLyricWordWrap = TRUE; //OpenԼ ɼǰ ĳҰ̴.

	DeleteLyricList();

	LOGFONT lf={0,};
	lf.lfHeight = -12 ;//-MulDiv(9, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	_tcscpy(lf.lfFaceName, _T("Arial"));
	m_hFont = CreateFontIndirect(&lf);
}

CKayLyricWnd::~CKayLyricWnd()
{
	DeleteLyricList();

	DeleteObject(m_hBrush);
	DeleteObject(m_hFont);
}

void CKayLyricWnd::RegisterClass()
{
#ifdef _WIN32_WCE_PPC
	m_hBrush = CreateSolidBrush(
#ifdef _WIN32_WCE
		((CPpcSkin*)(m_pParent->m_pSkin))->GetColor2(COLOR2_PLAYLISTBACK)
#else
		RGB(255,0,0)
#endif
	);
#else
	m_hBrush = CreateSolidBrush(
		((CSkin*)(m_pParent->m_pSkin))->GetColor(COLOR_INFO)
//		RGB(255,0,0)
	);
#endif
	WNDCLASS	wc;
	memset(&wc, 0, sizeof(WNDCLASS));
    wc.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
    wc.lpfnWndProc = (WNDPROC)LyricWndProc;
    wc.hInstance = GetInst();
    wc.hbrBackground = m_hBrush;
    wc.lpszClassName = LYRICWND_CLASS_NAME;
#ifndef _WIN32_WCE
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
#endif
	::RegisterClass(&wc);
}

void CKayLyricWnd::OnCreate(HWND hWnd)
{
	m_hWnd = hWnd;
}

void CKayLyricWnd::Show(CMainWnd* pParent, BOOL fShow /* = TRUE*/)
{
	if (!m_hWnd) {
		m_pParent = pParent;
#ifdef _WIN32_WCE
		Create(NULL, pParent->GetHandle(), WS_VISIBLE|WS_CHILD);
#else
		Create(NULL, pParent->GetHandle(), WS_VISIBLE|WS_OVERLAPPEDWINDOW);
#endif

//		RECT rtParent, rtThis;
//		GetWindowRect(m_pParent->GetHandle(), &rtParent);
//		GetWindowRect(m_hWnd, &rtThis);
//		MoveWindow(m_hWnd, rtParent.left-150, rtParent.top-90, rtThis.right-rtThis.left, rtThis.bottom-rtThis.top, FALSE);

#ifdef _WIN32_WCE
		SetParent(m_hWnd, m_pParent->GetHandle());
#endif
	}

	OnSize(SIZE_RESTORED,PPC_PLAYLIST_WIDTH,45);

	if(fShow) {
		ShowWindow(m_hWnd, SW_SHOW);
	//	SetForegroundWindow(m_hWnd);
		SetReDraw(TRUE);
	}
	else{
		ShowWindow(m_hWnd, SW_HIDE);
	}
}

BOOL CKayLyricWnd::Create(LPTSTR pszCmdLine, HWND hwndParent, DWORD dwStyle)
{
	RegisterClass();

//	RECT rt;
//	GetWindowRect(hwndParent, &rt);
//	TCHAR tt[100];
//	_stprintf(tt, _T("%d-%d-%d-%d"),rt.left,rt.top,rt.right,rt.bottom);
//	MessageBox(hwndParent, tt, _T("hwndParent"), MB_OK);

	// EChE쐬
#ifdef _WIN32_WCE
	CreateWindowEx(0, LYRICWND_CLASS_NAME, LYRICWND_TITLE, dwStyle,
		0, 0, 400, 80, hwndParent, NULL, GetInst(), this);
#else
	CreateWindowEx(WS_EX_ACCEPTFILES, LYRICWND_CLASS_NAME, LYRICWND_TITLE, dwStyle,
		0, 0, 400, 80, hwndParent, NULL, GetInst(), this);
#endif

	if (!m_hWnd)
		return FALSE;

	//OnSize(SIZE_MINIMIZED , 0, 0);

	return TRUE;
}

void CKayLyricWnd::Close()
{
	DestroyWindow(m_hWnd);
}

BOOL CALLBACK CKayLyricWnd::LyricWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static CKayLyricWnd* pLyricWnd;
	switch (uMsg) {
	case WM_CREATE:
	{
		CREATESTRUCT* pcs;
		pcs = (CREATESTRUCT*)lParam;
		pLyricWnd = (CKayLyricWnd*)pcs->lpCreateParams;
		pLyricWnd->OnCreate(hwnd);
		return 0;
	}
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			case IDCANCEL:
			case IDOK:
				//DestroyWindow(hwndDlg);
				ShowWindow(hwnd, SW_HIDE);
				return TRUE;
		}
		return FALSE;
	case WM_CLOSE:
		//DestroyWindow(hwndDlg);
		ShowWindow(hwnd, SW_HIDE);
		return TRUE;
	case WM_DESTROY:
		pLyricWnd->m_hWnd = NULL;
		return TRUE;
	case WM_MOVE:
//		pLyricWnd->OnMove(LOWORD(lParam), HIWORD(lParam));
		return TRUE;
#ifndef _WIN32_WCE
//	case WM_DROPFILES:
//		pLyricWnd->OnDropFiles((HDROP)wParam);
//		return TRUE;
#endif
	case WM_NOTIFY:
	{
		NMHDR* pnmh = (NMHDR*)lParam;
		switch (pnmh->code) {
		case LVN_KEYDOWN:
//			pLyricWnd->OnLyricKeyDown((NMLVKEYDOWN*)pnmh);
			return TRUE;
		case NM_DBLCLK:
//			pLyricWnd->OnLyricDblClk(pnmh);
			return TRUE;
		case LVN_BEGINDRAG:
//			pLyricWnd->OnLyricBeginDrag((NMLISTVIEW*)pnmh);
			return TRUE;
		case NM_RCLICK:
//			pLyricWnd->OnLyricRClick(pnmh);
			return TRUE;
		case NM_CLICK:
//			pLyricWnd->OnLyricClick(pnmh);
			return TRUE;
		}
		return FALSE;
	}
	case WM_MOUSEMOVE:
//		pLyricWnd->OnMouseMove((short)LOWORD(lParam), (short)HIWORD(lParam));
		return TRUE;
	case WM_LBUTTONUP:
	case WM_RBUTTONUP:
//		pLyricWnd->OnLButtonUp();
		return TRUE;
	case WM_TIMER:
		pLyricWnd->OnTimer(wParam);
		return 0;
	case WM_PAINT:
	{
		PAINTSTRUCT ps;
		HDC hDC = BeginPaint(hwnd, &ps);
		pLyricWnd->OnPaint(hDC, &ps);
		EndPaint(hwnd, &ps);
		return 0;
	}
	case WM_ERASEBKGND:
	{
		RECT rt;
		GetClipBox((HDC)wParam, &rt);
		if(pLyricWnd->m_hBrush) DeleteObject(pLyricWnd->m_hBrush);
		pLyricWnd->m_hBrush = CreateSolidBrush(
#ifdef _WIN32_WCE
			((CPpcSkin*)(pLyricWnd->m_pParent->m_pSkin))->GetColor2(COLOR2_PLAYLISTBACK)
#else
			RGB(255, 255, 255)
#endif
		);
		FillRect((HDC)wParam, &rt, pLyricWnd->m_hBrush);
		return TRUE;
	}
	case WM_CTLCOLORSTATIC:
	default:
		return DefWindowProc(hwnd, uMsg, wParam, lParam);
	}
}

BOOL CKayLyricWnd::LoadLyric(int iPos, FILEINFO* pInfo)
{
	KillTimer(m_hWnd, ID_TIMER_LYRIC);
	DeleteLyricList();
	m_pLyricList = new CMultiBuff();

	if(!m_pParent) return FALSE;
	if(!pInfo) return FALSE;

	BOOL ret = FALSE;
	TCHAR szLyricFileName[MAX_PATH];
	_tcscpy(szLyricFileName, pInfo->szPath);
	TCHAR* p = _tcsrchr(szLyricFileName, _T('.'));
	if(!p)
		return FALSE;
	_tcscpy(p, _T(".lrc"));
	ret = ParseLyricFile(szLyricFileName);
	if(ret) {
		//  ->    ٲ ȵȴ. -> qsort  ȵɰ .
		//׳ ̳ ҵ ɷ .
		//m_pLyricList->Sort( (LPCOMPAREFUNC)LyricCompare, (DWORD)this );//qsort ȵǿ~

		TCHAR buf[256]; buf[0] = _T('\0');
		if(m_pszTitle && m_pszArtist) {
			DWORD dwFlag=0;
			if(_tcslen(m_pszTitle))  dwFlag |= 0x10;
			if(_tcslen(m_pszArtist)) dwFlag |= 0x01;
			switch(dwFlag) {
			case 0x10:
				_sntprintf(buf, sizeof(buf)/sizeof(buf[0]), _T("%s"), m_pszTitle);
				break;
			case 0x01:
				_sntprintf(buf, sizeof(buf)/sizeof(buf[0]), _T("%s"), m_pszArtist);
				break;
			case 0x11:
				_sntprintf(buf, sizeof(buf)/sizeof(buf[0]), _T("%s - %s"), m_pszTitle, m_pszArtist);
				break;
			default:
				break;
			}
		}
		m_pszLyricInfo = new TCHAR[_tcslen(buf)+1];
		_tcscpy(m_pszLyricInfo, buf);

//kayws426{{debug only
#if defined(DEBUG) || defined(_DEBUG)
	TRACE0("Load Lyric Done\n");
	int count = m_pLyricList->GetCount();
	for(int i=0; i<count; i++) {
		LYRIC_INFO* pLyricInfo = (LYRIC_INFO*)m_pLyricList->GetAt(i);
		TRACE2("[%06d]%s\n", pLyricInfo->uTime, pLyricInfo->szLyric);
	}
#endif
//kayws426}}

		m_fLyricLoadOK = TRUE;
		SetTimer(m_hWnd, ID_TIMER_LYRIC, TIMER_LYRIC_INTERVAL, NULL);
	} else {
		m_fLyricLoadOK = FALSE;
		DeleteLyricList();
		KillTimer(m_hWnd, ID_TIMER_LYRIC);
	}
	SetReDraw(TRUE);

	return ret;
}

void CKayLyricWnd::OnTimer(UINT uID)
{
	switch(uID) {
		case ID_TIMER_LYRIC:
		{
			if(!m_pLyricList || m_pLyricList->IsEmpty()) {
				KillTimer(m_hWnd, ID_TIMER_LYRIC);
				return;
			}
			{//determineRePaint
				int iPos = CalcCurrentLyricPos();
				if(m_iLyricPos!=iPos) {
					m_iLyricPos = iPos;
					SetReDraw(TRUE);
				}
			}
			break;
		}
	}
}

BOOL CKayLyricWnd::Open(int nIndex, FILEINFO* pInfo)
{
	if(nIndex==OPEN_NONE)
		return FALSE;

	m_fLyricWordWrap = GetOptions()->m_fLyricWordWrap;//⼭ ɼ ĳѴ

	if( LoadLyric(nIndex, pInfo) ) {
		return TRUE;
	}
	return FALSE;
}

BOOL CKayLyricWnd::Play(int nIndex)
{
	SetTimer(m_hWnd, ID_TIMER_LYRIC, TIMER_LYRIC_INTERVAL, NULL);
//	MessageBox(m_hWnd, _T("Lyrics fonud"), _T("LyricWnd"), MB_OK);
	SetReDraw(TRUE);
	return FALSE;
}

void CKayLyricWnd::Stop()
{
//	m_iLyricPos = -1;
//	KillTimer(m_hWnd, ID_TIMER_LYRIC);
	SetReDraw(TRUE);
}

void CKayLyricWnd::ChangeTitle(LPTSTR str)
{
	SetWindowText(m_hWnd, str);
}

void CKayLyricWnd::OnPaint(HDC hDC, PAINTSTRUCT* pps)
{
	DrawLyric(hDC);
}

void CKayLyricWnd::DrawLyric(HDC hDC)
{
	if(!m_fLyricLoadOK)
		return;
	if(!m_pLyricList)
		return;
	const int count = m_pLyricList->GetCount();
	if(count<1)
		return;

#  ifdef _WIN32_WCE
	COLORREF crBackgrond = ((CPpcSkin*)(m_pParent)->m_pSkin)->GetColor2(COLOR2_PLAYLISTBACK);
	COLORREF crLyricDefalut = ((CPpcSkin*)(m_pParent)->m_pSkin)->GetColor2(COLOR2_PLAYLISTTEXT);
//	COLORREF crLyricActive = RGB(120,200,200);
//	COLORREF crLyricActive = RGB(20,120,200);
//	COLORREF crLyricActive = 0xFFFFFF & (~crBackgrond);
	COLORREF crLyricActive = RGB(
		GetRValue(crLyricDefalut) + (GetRValue(0xFFFFFF & (~crBackgrond))-GetRValue(crLyricDefalut))/2,
		GetGValue(crLyricDefalut) + (GetGValue(0xFFFFFF & (~crBackgrond))-GetGValue(crLyricDefalut))/2,
		GetBValue(crLyricDefalut) + (GetBValue(0xFFFFFF & (~crBackgrond))-GetBValue(crLyricDefalut))/2,
		);
	COLORREF crShadow = RGB(
		GetRValue(crBackgrond) + (GetRValue(crLyricActive)-GetRValue(crBackgrond))/2,
		GetGValue(crBackgrond) + (GetGValue(crLyricActive)-GetGValue(crBackgrond))/2,
		GetBValue(crBackgrond) + (GetBValue(crLyricActive)-GetBValue(crBackgrond))/2,
		);
//	COLORREF tmp = crLyricDefalut;
//	crLyricDefalut = crLyricActive;
//	crLyricActive = tmp;
#  else
	COLORREF crLyricDefalut = RGB(0, 0, 0);
	COLORREF crLyricActive = RGB(20,120,200);
	COLORREF crShadow = RGB(200,200,200);
#  endif

	//{{DC 
	RECT rtClnt;
	GetClientRect(m_hWnd, &rtClnt);
	rtClnt.top += 1; rtClnt.bottom -= 1;
	if( ((CKayOptions*)m_pParent->m_pOptions)->m_fLyricWndPos&CKayOptions::LyricWndPos_Down ) {
		rtClnt.top  += 4; rtClnt.bottom -= 3;
	}
	int clientWidth = rtClnt.right - rtClnt.left;
	HGDIOBJ hFont = SelectObject(hDC, m_hFont);
	SetBkMode(hDC, TRANSPARENT);
	//}}

	TCHAR buf[1024]; buf[0] = _T('\0');
	int iLyricPos = m_iLyricPos;
	BOOL fReTry = FALSE;//!

_reTry:
	LYRIC_INFO *pPrev = NULL;
	LYRIC_INFO *pCurr = NULL;
	LYRIC_INFO *pNext = NULL;
	if(iLyricPos-1>=0 && iLyricPos-1<count)
		pPrev = (LYRIC_INFO*)m_pLyricList->GetAt(iLyricPos-1);
	if(iLyricPos>=0 && iLyricPos<count)
		pCurr = (LYRIC_INFO*)m_pLyricList->GetAt(iLyricPos);
	if(iLyricPos+1>=0 && m_iLyricPos+1<count)
		pNext = (LYRIC_INFO*)m_pLyricList->GetAt(iLyricPos+1);

	if(pPrev&&pPrev->szLyric) {
		_tcscpy(buf, pPrev->szLyric);
	}
	else {
		if(m_pszLyricInfo)
			_tcscpy(buf, m_pszLyricInfo);
	}

	//{{⿡ 簡   ó߰
	//if   : pPrev pCurr ÿ ؼ 簡  iLyricPos 
	if(!fReTry && m_fLyricWordWrap) {//óѹ Ѵ
		fReTry = TRUE;//óѹ Ѵ
		SIZE sz;
		GetTextExtentPoint32(hDC, buf, _tcslen(buf), &sz);
		if(sz.cx>clientWidth) {
			iLyricPos += 1;
			goto _reTry;
		}
		else if(pCurr&&pCurr->szLyric){
			GetTextExtentPoint32(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &sz);
			if(sz.cx>clientWidth) {
				iLyricPos += 1;
				goto _reTry;
			}
		}
	}
	//if   : pNext    ǥþϰų óκи 
	//}} 簡   ó߰

#if 0
	_tcscat(buf, _T("\n"));
	if(pCurr&&pCurr->szLyric) {
		_tcscat(buf, pCurr->szLyric);
	}

	_tcscat(buf, _T("\n"));
	if(pNext&&pNext->szLyric) {
		_tcscat(buf, pNext->szLyric);
	}
	_tcscat(buf, _T("\n"));

	SetTextColor(hDC, crLyricDefalut);
	if(m_fLyricWordWrap)
		DrawText(hDC, buf, _tcslen(buf), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
	else
		DrawText(hDC, buf, _tcslen(buf), &rtClnt, DT_NOPREFIX|DT_CENTER);
#else
	RECT rtOneLine = {0,0,100,100};
	DrawText(hDC, _T(" "), _tcslen(_T(" ")), &rtOneLine, DT_NOPREFIX|DT_CALCRECT);
	int lineSpace = rtOneLine.bottom;

	RECT rtCalc;
	if(m_fLyricWordWrap) { // 左 
		if(iLyricPos == m_iLyricPos) { //簡 ̸..
			if( _tcslen(buf) ) {
				SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
				SetTextColor(hDC, crLyricDefalut);
				DrawText(hDC, buf, _tcslen(buf), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				DrawText(hDC, buf, _tcslen(buf), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK|DT_CALCRECT);
				rtClnt.top = rtCalc.bottom;
			} else {rtClnt.top += lineSpace;}
			if(pCurr&&pCurr->szLyric) {
				SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
				{
					RECT _rt = {rtClnt.left+1, rtClnt.top+1, rtClnt.right+1, rtClnt.bottom+1};
					SetTextColor(hDC, crShadow);
					DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &_rt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				}
				SetTextColor(hDC, crLyricActive);
				DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK|DT_CALCRECT);
				rtClnt.top = rtCalc.bottom;
			} else {rtClnt.top += lineSpace;}
			if(pNext&&pNext->szLyric) {
				//SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
				SetTextColor(hDC, crLyricDefalut);
				DrawText(hDC, pNext->szLyric, _tcslen(pNext->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				//DrawText(hDC, pNext, _tcslen(pNext), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK|DT_CALCRECT);
				//rtClnt.top = rtCalc.bottom;
			}
		}
		else { //簡  ƴϸ..
			if(pPrev&&pPrev->szLyric) {
				SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
				{
					RECT _rt = {rtClnt.left+1, rtClnt.top+1, rtClnt.right+1, rtClnt.bottom+1};
					SetTextColor(hDC, crShadow);
					DrawText(hDC, pPrev->szLyric, _tcslen(pPrev->szLyric), &_rt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				}
				SetTextColor(hDC, crLyricActive);
				DrawText(hDC, pPrev->szLyric, _tcslen(pPrev->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				DrawText(hDC, pPrev->szLyric, _tcslen(pPrev->szLyric), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK|DT_CALCRECT);
				rtClnt.top = rtCalc.bottom;
			} else {rtClnt.top += lineSpace;}
			if(pCurr&&_tcslen(pCurr->szLyric)) {
				SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
				SetTextColor(hDC, crLyricDefalut);
				DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
				DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK|DT_CALCRECT);
				rtClnt.top = rtCalc.bottom;
			}
			if(pNext&&pNext->szLyric) {
				if( (rtClnt.bottom - rtClnt.top) >= lineSpace ) {
					//SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
					//SetTextColor(hDC, crLyricDefalut);
					DrawText(hDC, pNext->szLyric, _tcslen(pNext->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
					//DrawText(hDC, pNext, _tcslen(pNext), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK|DT_CALCRECT);
					//rtClnt.top = rtCalc.bottom;
				}
			}
		}
	}
	else { // 左 尡 ƴ
		if( _tcslen(buf) ) {
			SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
			SetTextColor(hDC, crLyricDefalut);
			DrawText(hDC, buf, _tcslen(buf), &rtClnt, DT_NOPREFIX|DT_CENTER);
			DrawText(hDC, buf, _tcslen(buf), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_CALCRECT);
			rtClnt.top = rtCalc.bottom;
		} else {rtClnt.top += lineSpace;}
		if(pCurr&&pCurr->szLyric) {
			SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
			{
				RECT _rt = {rtClnt.left+1, rtClnt.top+1, rtClnt.right+1, rtClnt.bottom+1};
				SetTextColor(hDC, crShadow);
				DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &_rt, DT_NOPREFIX|DT_CENTER|DT_WORDBREAK);
			}
			SetTextColor(hDC, crLyricActive);
			DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER);
			DrawText(hDC, pCurr->szLyric, _tcslen(pCurr->szLyric), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_CALCRECT);
			rtClnt.top = rtCalc.bottom;
		} else {rtClnt.top += lineSpace;}
		if(pCurr&&pCurr->szLyric) {
			//SetRect(&rtCalc, rtClnt.left, rtClnt.top, rtClnt.right, rtClnt.bottom);
			SetTextColor(hDC, crLyricDefalut);
			DrawText(hDC, pNext->szLyric, _tcslen(pNext->szLyric), &rtClnt, DT_NOPREFIX|DT_CENTER);
			//DrawText(hDC, pNext, _tcslen(pNext), &rtCalc, DT_NOPREFIX|DT_CENTER|DT_CALCRECT);
			//rtClnt.top = rtCalc.bottom;
		}
	}
#endif

	SelectObject(hDC, hFont);
	return;
}

void CKayLyricWnd::DrawLyric2(HDC hDC, int iIndex)
{
	int count = 0;
//	if(!m_fLyricLoadOK) return;
	if(m_pLyricList) {
		count = m_pLyricList->GetCount();
		if(count<1)
			return;
	}
	LYRIC_INFO *pPrev, *pCurr, *pNext, *pLyricInfo;
	UINT umSec = MAP_GetCurrent(((CKayMainWnd*)m_pParent)->GetMapHandle());
	for(int i=0; i<count; i++) {
		pLyricInfo = (LYRIC_INFO*)m_pLyricList->GetAt(i);
		if(umSec<=pLyricInfo->uTime)
			break;
	}
	if(i<2) {
		pPrev = NULL;
		pCurr = NULL;
		pNext = (LYRIC_INFO*)m_pLyricList->GetAt(i);
	} else if(i==count) {
		pPrev = (LYRIC_INFO*)m_pLyricList->GetAt(i-2);
		pCurr = (LYRIC_INFO*)m_pLyricList->GetAt(i-1);
		pNext = NULL;
	} else {
		pPrev = (LYRIC_INFO*)m_pLyricList->GetAt(i-2);
		pCurr = (LYRIC_INFO*)m_pLyricList->GetAt(i-1);
		pNext = (LYRIC_INFO*)m_pLyricList->GetAt(i);
	}

	LOGFONT lf={0,};
	lf.lfHeight = -9;//MulDiv(9, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	_tcscpy(lf.lfFaceName, _T("Arial"));
	HGDIOBJ hFont = SelectObject(hDC, CreateFontIndirect(&lf));

	RECT rt;
	GetClientRect(m_hWnd, &rt);
//	DrawText(hDC, lklk, 500, &rt, DT_CENTER);
//	if(pPrev) TextOut(hDC, 5, 5, pPrev->szLyric, _tcslen(pPrev->szLyric));
//	if(pCurr) TextOut(hDC, 5,25, pCurr->szLyric, _tcslen(pCurr->szLyric));
//	if(pNext) TextOut(hDC, 5,45, pNext->szLyric, _tcslen(pNext->szLyric));

	SelectObject(hDC, hFont);
	return;
}

BOOL CKayLyricWnd::ParseLyric(LPTSTR szLyric)
{
	int iLyricSize = _tcslen(szLyric);
	TCHAR* pEndOfStr = &szLyric[iLyricSize];
	TCHAR* pStr = &szLyric[0];
	while( pStr && pStr<pEndOfStr) {
		TCHAR* pCR = _tcschr(pStr, '\r');
		TCHAR* pLF = _tcschr(pStr, '\n');
		if(pCR==NULL) pCR = (TCHAR*)-1;
		if(pLF==NULL) pLF = (TCHAR*)-1;
		TCHAR* pLineEnd = min(pCR, pLF);
		if(pLineEnd!=(TCHAR*)-1) {
			TCHAR* pLyric = new TCHAR[pLineEnd-pStr+1];
			_tcsncpy(pLyric, pStr, pLineEnd-pStr);
			pLyric[pLineEnd-pStr] = '\0';
			LYRIC_INFO* pLyricInfo = new LYRIC_INFO(0, pLyric);
			m_pLyricList->Add((DWORD)pLyricInfo);
		}
		pStr = pLineEnd + 1;
	}
	return TRUE;
}

BOOL CKayLyricWnd::ParseLyricFile2(LPTSTR szLyricFileName)
{
	FILE* pFile = _tfopen(szLyricFileName, _T("r"));
	if(NULL==pFile)
		return FALSE;

	TCHAR buf[512];
	fseek(pFile, 0, SEEK_END);
	LONG fileSize = ftell(pFile);
	fseek(pFile, 0, SEEK_SET);

	int iZeroTimeFound = 0;
	UINT uTime = 0, uLastTime = 0, minute, sec, mSec;
	while( NULL!=_fgetts(buf, sizeof(buf), pFile) ) {

		int length = _tcslen(buf);
		if( 0==_tcsnicmp(buf, _T("[ar:"), 4) ) {

			TCHAR* pChar = _tcsrchr(buf, _T(']'));
			m_pszArtist = new TCHAR[pChar-buf-4+1];
			_tcsncpy(m_pszArtist, buf+4, pChar-buf-4);
			m_pszArtist[pChar-buf-4] = _T('\0');

		} else if( 0==_tcsnicmp(buf, _T("[ti:"), 4) ) {

			TCHAR* pChar = _tcsrchr(buf, _T(']'));
			m_pszTitle = new TCHAR[pChar-buf-4+1];
			_tcsncpy(m_pszTitle, buf+4, pChar-buf-4);
			m_pszTitle[pChar-buf-4] = _T('\0');

		} else if( 0==_tcsnicmp(buf, _T("[al:"), 4) ) {

			TCHAR* pChar = _tcsrchr(buf, _T(']'));
			m_pszAlbum = new TCHAR[pChar-buf-4+1];
			_tcsncpy(m_pszAlbum, buf+4, pChar-buf-4);
			m_pszAlbum[pChar-buf-4] = _T('\0');

		} else if(length>9 && buf[9]==']') {

			if(3==_stscanf(buf, _T("[%d:%d.%d]"), &minute, &sec, &mSec)) {
				uTime = minute*60*1000 + sec*1000 + mSec*10;
			}
			TCHAR* pszLyric = new TCHAR[length-10+1];
			_tcsncpy(pszLyric, &buf[10], length-10);
			pszLyric[length-10] = _T('\0');

			if(uTime==0/*||_tcslen(pszLyric)==0*/) {
				iZeroTimeFound++;
			} else {
				if(iZeroTimeFound) {
					int count = m_pLyricList->GetCount();
					for(int i=iZeroTimeFound; i>0; i--) {
						LYRIC_INFO* pLyricInfo = (LYRIC_INFO*)m_pLyricList->GetAt(count-i);
						pLyricInfo->uTime = uLastTime + (  ( (uTime-uLastTime)*i ) / (iZeroTimeFound+1)  );
					}
					iZeroTimeFound = 0;
				}
				uLastTime = uTime;
			}
			//ϴ ..
			LYRIC_INFO* pLyricInfo = new LYRIC_INFO(uTime, pszLyric);
			m_pLyricList->Add((DWORD)pLyricInfo);

		}
	}
	fclose(pFile);
	return TRUE;
}

BOOL CKayLyricWnd::ParseLyricFile(LPTSTR szLyricFileName)
{
	FILE* pFile = _tfopen(szLyricFileName, _T("r"));
	if(NULL==pFile)
		return FALSE;

	fseek(pFile, 0, SEEK_END);
	LONG fileSize = ftell(pFile);
	fseek(pFile, 0, SEEK_SET);
	// ũⰡ 50KB ̸̻  ~
	if(fileSize > 50*1024)
		return FALSE;
	CHAR* szLyric = new CHAR[fileSize+1];
	size_t readCount = fread(szLyric, sizeof(szLyric[0]), fileSize, pFile);
	szLyric[readCount] = '\0';
	fclose(pFile);

#if defined(UNICODE) || defined(_UNICODE)
	int reqBufferSize = MultiByteToWideChar(CP_ACP, 0, szLyric, readCount+1, NULL, 0);
	WCHAR* wszLyric = new WCHAR[reqBufferSize];
	int convertedSize = MultiByteToWideChar(CP_ACP, 0, szLyric, readCount+1, wszLyric, reqBufferSize);
	BOOL ret = ParseLyricFromString(wszLyric);
	delete[] wszLyric;
#else
	BOOL ret = ParseLyricFromString(szLyric);
#endif

	delete[] szLyric;
	return ret;
}

BOOL CKayLyricWnd::ParseLyricFromString(LPTSTR szLyricString)
{
	ASSERT(szLyricString!=NULL);
	int iLyricSize = _tcslen(szLyricString);
	if(iLyricSize<5)
		return FALSE;
	TCHAR* pEndOfStr = &szLyricString[iLyricSize];
	TCHAR* pStr = &szLyricString[0];

	int iZeroTimeFound = 0;
	UINT uTime = 0, uLastTime = 0;
	TRACE(szLyricString);TRACE0("\n");

	TCHAR* pNextLineBeg = pStr;
	while( pStr && pStr<pEndOfStr) {
		//move to nextLine
		pStr = pNextLineBeg;

		//skip left spaces
		while( *pStr==_T(' ') || *pStr==_T('\t') ) pStr++;
		//ٳ ٱ 
		TCHAR* pTmpStr = pStr;
		while(*pTmpStr!=_T('\0')) {
			if( (*pTmpStr==_T('\n') || *pTmpStr==_T('\r')) ) break;
			pTmpStr++;
		}
		TCHAR* pLineEnd = pTmpStr;
		int iLineLength = pTmpStr - pStr;
		// ۾˾Ƴ
		while( (*pTmpStr==_T('\n') || *pTmpStr==_T('\r')) ) pTmpStr++;
		pNextLineBeg = pTmpStr;


		//.. 뷡 ã´.
		TCHAR** pTarget = NULL;
		BOOL bFound = FALSE;
		if( 0==_tcsnicmp(pStr, _T("[ar:"), 4) ) {
			pTarget = &m_pszArtist;
			bFound = TRUE;
		} else if( 0==_tcsnicmp(pStr, _T("[ti:"), 4) ) {
			pTarget = &m_pszTitle;
			bFound = TRUE;
		} else if( 0==_tcsnicmp(pStr, _T("[al:"), 4) ) {
			pTarget = &m_pszAlbum;
			bFound = TRUE;
		}
		if(bFound && NULL!=pTarget) {
			TCHAR* pChar = pLineEnd;
			while(*pChar!=_T(']') && pChar>pStr) --pChar;
			if(pChar>pStr) {
				*pTarget = new TCHAR[pChar-pStr-4+1];
				_tcsncpy(*pTarget, pStr+4, pChar-pStr-4);
				(*pTarget)[pChar-pStr-4] = _T('\0');
			}
		}
		else {
			//  ã´
			TCHAR* _pLyricStrStart = _tcschr(pStr, _T(']'));
			if(_pLyricStrStart==NULL)
				continue;
			else {
				// ĭ ŵ
				++_pLyricStrStart;
				while(*_pLyricStrStart==_T(' '))
					++_pLyricStrStart;
			}
			//  ã´
			TCHAR* _pLyricStrEnd = pLineEnd;
			//  ĭ ŵ
			while(*(_pLyricStrEnd-1)==_T(' '))
				--_pLyricStrEnd;

			//  (ĭ ̹ ŵߴ)
			int iLyricStrLen = _pLyricStrEnd - _pLyricStrStart;
			if(iLyricStrLen<=0)
				continue;

			// ð ´
			//scanf    Ƿ  0  ʱȭ Ѵ
			{
				uTime = 0;
				float _msec = 0;
				float _min = 0;
				TCHAR _c = 0;
				_stscanf(pStr, _T("[%f%c%f]"), &_min, &_c, &_msec);
				if(_c == _T(':')) {
					uTime = (int)(_min*60000.0f+0.5f) + (int)(_msec*1000.0f+0.5f);
				} else {
					uTime = (int)(_min*1000.0f+0.5f);
				}
			}

			TCHAR* pszLyric = new TCHAR[iLyricStrLen+1];
			_tcsncpy(pszLyric, _pLyricStrStart, iLyricStrLen);
			pszLyric[iLyricStrLen] = _T('\0');
			TRACE1("%s\n", pszLyric);

			if(uTime==0) {
				iZeroTimeFound++;
			} else {
				if(iZeroTimeFound) {
					int count = m_pLyricList->GetCount();
					for(int i=0; i<iZeroTimeFound; i++) {
						LYRIC_INFO* pLyricInfo = (LYRIC_INFO*)m_pLyricList->GetAt(count-iZeroTimeFound+i);
						pLyricInfo->uTime = uLastTime + (  ( (uTime-uLastTime)*(i+1) ) / (iZeroTimeFound+1)  );
					}
					iZeroTimeFound = 0;
				}
				uLastTime = uTime;
			}
			{
				TCHAR* lineEnd = pszLyric+_tcslen(pszLyric);
				TCHAR* p = pszLyric;

				while(p<lineEnd) {
					TCHAR* pMark = _tcschr(p, _T('/'));
					if(pMark) *pMark = _T('\0');
					else break;//̶
					TCHAR* lr = new TCHAR[_tcslen(p)+1];
					_tcscpy(lr, p);
					LYRIC_INFO* pLyricInfo = new LYRIC_INFO(uTime, lr);
					m_pLyricList->Add((DWORD)pLyricInfo);
					iZeroTimeFound++;
					p = pMark + 1;
				}
				if(p!=pszLyric) {
					TCHAR* tmp = new TCHAR[_tcslen(p)+1];
					_tcscpy(tmp, p);
					delete[] pszLyric;
					pszLyric = tmp;
				}
				LYRIC_INFO* pLyricInfo = new LYRIC_INFO(uTime, pszLyric);
				m_pLyricList->Add((DWORD)pLyricInfo);
			}

		}

	}//while

	return TRUE;
}

BOOL CKayLyricWnd::DeleteLyricList()
{
	if(m_pLyricList && !m_pLyricList->IsEmpty()) {
		for(int i = m_pLyricList->GetCount();i>0;i--) {
			LYRIC_INFO* pLyricInfo = (LYRIC_INFO*)m_pLyricList->RemoveAt(i-1);
			delete pLyricInfo;
		}
	}
	SAFE_DELETE_ARRAY(m_pszLyricInfo);
	SAFE_DELETE_ARRAY(m_pszAlbum);
	SAFE_DELETE_ARRAY(m_pszTitle);
	SAFE_DELETE_ARRAY(m_pszArtist);
	SAFE_DELETE(m_pLyricList);
	m_fLyricLoadOK = FALSE;
	m_iLyricPos = -3;
	SetLyricSyncReset();
	return TRUE;
}

void CKayLyricWnd::SetReDraw(BOOL fErase)
{
	RECT rt;
	GetClientRect(m_hWnd, &rt);
	InvalidateRect(m_hWnd, &rt, fErase);
}

int CKayLyricWnd::CalcCurrentLyricPos()
{
	if(!m_pLyricList) return -3;
	if(!m_fLyricLoadOK) return -4;
	int count = m_pLyricList->GetCount();
	if(count<1)
		return -1;
	int umSec = MAP_GetCurrent(((CKayMainWnd*)m_pParent)->GetMapHandle());

	for(int i=0; i<count; i++) {//ȹٷ 
		LYRIC_INFO* pLyricInfo = (LYRIC_INFO*)m_pLyricList->GetAt(i);
		if( (umSec+m_iTimeShift) <= (int)pLyricInfo->uTime ) {
			if(i>=m_nDisplayLines) {
				LYRIC_INFO* prevLyricInfo = (LYRIC_INFO*)m_pLyricList->GetAt(i-1);
				LYRIC_INFO* tmpLyricInfo  = (LYRIC_INFO*)m_pLyricList->GetAt(i-m_nDisplayLines);
				if(prevLyricInfo && tmpLyricInfo && prevLyricInfo->uTime==tmpLyricInfo->uTime)
					return i-2;//m_nDisplayLines  ǥõǵ
			}
			return i-1;
		}
	}

	return i-1;
}

void CKayLyricWnd::OnSize(UINT nType, int cx, int cy)
{
#ifdef _WIN32_WCE
	DWORD fLyricWndPos = ((CKayPpcOptions*)m_pParent->m_pOptions)->m_fLyricWndPos;
	if(fLyricWndPos&CKayPpcOptions::LyricWndPos_Up) {
		MoveWindow(m_hWnd, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP-10, cx, cy, TRUE);
	}
	else if(fLyricWndPos&CKayPpcOptions::LyricWndPos_Down) {
		MoveWindow(m_hWnd, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP+PPC_PLAYLIST_HEIGHT-45-7, cx, cy+7, TRUE);
	}
	else {
		MoveWindow(m_hWnd, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP-10, cx, cy, TRUE);
	}
	return;
#endif
	MoveWindow(m_hWnd, PPC_PLAYLIST_LEFT, PPC_PLAYLIST_TOP-10,
		cx, cy, TRUE);
}

int CALLBACK CKayLyricWnd::LyricCompare(LYRIC_INFO* pLeft, LYRIC_INFO* pRight, CKayLyricWnd* pLyricWnd)
{
	if(pLeft && pRight)
		return pLeft->uTime - pRight->uTime;
	else
		return 0;
}

void CKayLyricWnd::SetLyricSyncReset()
{
	m_iTimeShift = 0;
}

void CKayLyricWnd::SetLyricSyncShift(int iTimeShift)
{
	m_iTimeShift += iTimeShift;
}

