// KayPpcOptions.cpp: implementation of the CKayPpcOptions class.
//
//////////////////////////////////////////////////////////////////////

#include "KayPpcOptions.h"
#include "KayPpcMainWnd.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClickChecker gClickChecker;

CClickChecker::CClickChecker() : state(0), nID(0), modifiers(0), virtKey(0) {}

void CClickChecker::ProcessHotKey(HWND hwndDlg, unsigned short keyMode) {
	//if (hWndOwner==NULL) return;
	//pOptions->KeyMapPageProcessHotKey(hwndDlg, nID, modifiers, virtKey, keyMode);
}

int CClickChecker::OnTimer(HWND hwnd, UINT uID)
{
	if (uID == ID_TIMER_CLICKCHECK) {
		KillTimer(hwnd, ID_TIMER_CLICKCHECK);
		if (state) {
			int mode = state;
			if(GetAsyncKeyState(virtKey)) {
				TRACE1("hold %d\n", mode & ~KEYTYPE_HOLD);
				mode |= KEYTYPE_HOLD;
			} else {
				TRACE1("click %d\n", mode & ~KEYTYPE_HOLD);
			}
			state = 0;
			return mode;
		}
		//::MessageBox(hwndDlg, _T("single"), _T("click"), MB_OK);
	}
	return 0;
}

int CClickChecker::OnHotKey(HWND hwnd, int nId, UINT fuModifiers, UINT uVirtKey)
{
	int ret = 0;
	if (fuModifiers & MOD_KEYUP) {
		TRACE0("up\n");
		//::MessageBox(hwndDlg, _T("up"), _T("up"), MB_OK);

	} else {
		TRACE0("down\n");
		//::MessageBox(hwndDlg, _T("down"), _T("down"), MB_OK);
		if(state) {
			KillTimer(hwnd, ID_TIMER_CLICKCHECK);
		}
		if (nID != nId && state != 0) { //XXX
			//Ű 
			ret = state;
			state = 0;
		}
		if (state == 0) {
			nID = nId;
			modifiers = fuModifiers;
			virtKey = uVirtKey;
		}
		++state;
		SetTimer(hwnd, ID_TIMER_CLICKCHECK, TIMER_CLICKCHECK_INTERVAL, NULL);
		//::MessageBox(hwndDlg, _T("double"), _T("click"), MB_OK);
	}
	return ret;
}

CKayPpcOptions::CKayPpcOptions()
{

}

CKayPpcOptions::~CKayPpcOptions()
{

}

int CKayPpcOptions::OnTimer(HWND hwnd, UINT uID)//for CPpcOptions and CKayPpcOptions
{
	int mode = gClickChecker.OnTimer(hwnd, uID);
	if(mode) {
		KeyMapPageProcessHotKey2(hwnd, gClickChecker.nID, gClickChecker.modifiers, gClickChecker.virtKey, mode);
	}
	return mode;
}

void CKayPpcOptions::KeyMapPageOnHotKey(HWND hwndDlg, int nId, UINT fuModifiers, UINT uVirtKey)
{
	int _nID       = gClickChecker.nID;
	int _modifiers = gClickChecker.modifiers;
	int _virtKey   = gClickChecker.virtKey;
	int mode = gClickChecker.OnHotKey(hwndDlg, nId, fuModifiers, uVirtKey);
	if(mode) {
		KeyMapPageProcessHotKey2(hwndDlg, _nID, _modifiers, _virtKey, mode);
	}
}

void CKayPpcOptions::KeyMapPageProcessHotKey2(HWND hwndDlg, int nId, UINT fuModifiers, UINT uVirtKey, unsigned short keyMode)
{
	HWND hwndLV = GetDlgItem(hwndDlg, IDC_LIST_KEYMAP);
	HWND hwndCmb = GetDlgItem(hwndDlg, IDC_CMB_FUNC);

	BYTE _fVirt = FVIRTKEY;
	if (fuModifiers & MOD_ALT)
		_fVirt |= FALT;
	if (fuModifiers & MOD_CONTROL)
		_fVirt |= FCONTROL;
	if (fuModifiers & MOD_SHIFT)
		_fVirt |= FSHIFT;
	if (fuModifiers & MOD_WIN)
		_fVirt |= FWIN;

	int nSel = SendMessage(hwndCmb, CB_GETCURSEL, 0, 0);
	if (nSel != 0 && nSel != CB_ERR) {
		if (s_nCommands[nSel - 1] == IDM_DELETE_KEYMAP) {
			int nCount = ListView_GetItemCount(hwndLV);
			for (int i = 0; i < nCount; i++) {
				LVITEM li;
				memset(&li, 0, sizeof(LVITEM));
				li.mask = LVIF_PARAM;
				li.iItem = i;
				ListView_GetItem(hwndLV, &li);
				ACCEL* pac = (ACCEL*)li.lParam;
//kayws426{{
				//if (pac->key == uVirtKey)
				if (_fVirt == pac->fVirt && uVirtKey == pac->key && keyMode == pac->pad ) {
//kayws426}}
					delete pac;
					ListView_DeleteItem(hwndLV, i);
					break;
				}
			}
		}
		else {
			ACCEL accel;
			accel.cmd = s_nCommands[nSel - 1];
			accel.key = uVirtKey;
			accel.fVirt = FVIRTKEY;
//kayws426{{
			accel.pad = keyMode;
			accel.fVirt = _fVirt;

			int nIndex = KeyMapPageAddMap(hwndDlg, &accel);
//kayws426}}
			ListView_SetItemState(hwndLV, nIndex, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED);
			ListView_EnsureVisible(hwndLV, nIndex, FALSE);
		}
	}
	SendMessage(hwndCmb, CB_SETCURSEL, 0, 0);
}

#define COLUMN_KEY		0
#define COLUMN_COMMAND	1
int CKayPpcOptions::KeyMapPageAddMap(HWND hwndDlg, ACCEL* pAccel)
{
	TCHAR szBuf[MAX_PATH];
	HWND hwndLV = GetDlgItem(hwndDlg, IDC_LIST_KEYMAP);

	// d`FbN
	int nCount = ListView_GetItemCount(hwndLV);
	for (int i = 0; i < nCount; i++) {
		LVITEM li;
		memset(&li, 0, sizeof(LVITEM));
		li.mask = LVIF_PARAM;
		li.iItem = i;
		ListView_GetItem(hwndLV, &li);

		ACCEL* p = (ACCEL*)li.lParam;
//kayws426{{
		//if (p->fVirt == pAccel->fVirt && p->key == pAccel->key) {
		if (p->fVirt == pAccel->fVirt && p->key == pAccel->key && p->pad == pAccel->pad ) {
//kayws426}}
			p->cmd = pAccel->cmd;
			// commandu
			KeyMapPageCreateCommandString(p->cmd, szBuf);
			ListView_SetItemText(hwndLV, i, COLUMN_COMMAND, szBuf);
			return i;
		}
	}

	// VKǉ
	ACCEL* p = new ACCEL;
	*p = *pAccel;

	LVITEM li;
	memset(&li, 0, sizeof(LVITEM));
	li.mask = LVIF_PARAM;
	li.iItem = nCount;
	li.lParam = (long)p;
	ListView_InsertItem(hwndLV, &li);

	// key쐬
//kayws426{{
	KeyMapPageCreateKeyString2(p->key, szBuf, p->pad);
//kayws426}}
	ListView_SetItemText(hwndLV, nCount, COLUMN_KEY, szBuf);

	// command쐬
	KeyMapPageCreateCommandString(p->cmd, szBuf);
	ListView_SetItemText(hwndLV, nCount, COLUMN_COMMAND, szBuf);

	return nCount;
}

void CKayPpcOptions::KeyMapPageRegisterHotKeys(HWND hwndDlg)
{
	for (int i = 0; i < s_uKeys_size; i++) {
#if defined(DEBUG) || defined(_DEBUG)
		BOOL bRet = RegisterHotKey(hwndDlg, s_uKeys[i][2], s_uKeys[i][1]|MOD_KEYUP, s_uKeys[i][2]);
		if(!bRet) {
			TRACE1("RegisterHotKey failed: VK=0x%02x\n", s_uKeys[i][2]);
		}
#else
		RegisterHotKey(hwndDlg, s_uKeys[i][2], s_uKeys[i][1]|MOD_KEYUP, s_uKeys[i][2]);
#endif
	}
}

void CKayPpcOptions::KeyMapPageUnregisterHotKeys(HWND hwndDlg)
{
	for (int i = 0; i < s_uKeys_size; i++) {
#if defined(DEBUG) || defined(_DEBUG)
		BOOL bRet = UnregisterHotKey(hwndDlg, s_uKeys[i][2]);
		if(!bRet) {
			TRACE1("UnregisterHotKey failed: VK=0x%02x\n", s_uKeys[i][2]);
		}
#else
		UnregisterHotKey(hwndDlg, s_uKeys[i][2]);
#endif
	}
}

void CKayPpcOptions::KeyMapPageCreateKeyString2(UINT uKey, LPTSTR psz, DWORD pressType)
{
	KeyMapPageCreateKeyString(uKey, psz);
	if(pressType==0)
		return;

	//Ű   ǥ
	TCHAR szInfo[MAX_PATH];
	szInfo[0] = 0;
	int count = pressType & (~KEYTYPE_HOLD);
	if (count == 1) {
		CTempStr keyInfo(IDS_KEY_INFO_SINGLE);
		if ( _tcscmp(keyInfo, _T(" ")) != 0 ) {
			// ִ 츸
			_tcscat(szInfo, keyInfo);
		}
	} else if (count == 2) {
		CTempStr keyInfo(IDS_KEY_INFO_DOUBLE);
		_tcscat(szInfo, keyInfo);
	} else {
		CTempStr keyInfo(IDS_KEY_INFO_XTIMES);
		_stprintf(szInfo, keyInfo, count);
	}
	//Ȧ  ǥ
	if (pressType & KEYTYPE_HOLD) {
		CTempStr keyInfo(IDS_KEY_INFO_HOLD);
		if ( _tcslen(szInfo) == 0 ) {
			//   ĭ 
			TCHAR* p = keyInfo;
			if(*p==_T(' ')) {
				_tcscat(szInfo, p+1);
			} else {
				_tcscat(szInfo, p);
			}
		}
		else {
			_tcscat(szInfo, keyInfo);
		}
	}
	// 
	if(_tcslen(szInfo)) {
		CTempStr keyInfo(IDS_KEY_INFO_INFO);
		_stprintf(psz+_tcslen(psz), _T("(%s)"), szInfo);
	}
//kayws426}}
}
