@echo off
REM  Set environment for the emulator target
REM  This batch file serves as a template only.
Title WCE emulator Environment


REM This batch file sets up an environment for building for a specific CPU from the command line.
REM The build environment defaults to the SDK for Pocket PC 2003 platform. The macros that control the
REM platform are: PLATFORM, OSVERSION, WCEROOT and SDKROOT. The SDK for Pocket PC 2003 default settings
REM are as follows:
REM    PLATFORM=POCKET PC 2003
REM        OSVERSION=WCE420
REM        WCEROOT=C:\Windows CE Tools    //Root dir for VCCE
REM        SDKROOT=C:\Windows CE Tools    //Root dir for Pocket PC 2003 SDK
REM The batch file uses these macros to set the PATH, INCLUDE, LIB macros for the default
REM platform. Please note that if the default setup options were altered during
REM installation (for example, if the install directories were changed), then the user needs
REM to modify these macros accordingly.

if "%OSVERSION%"=="" set OSVERSION=WCE420
if "%PLATFORM%"=="" set PLATFORM=POCKET PC 2003
if "%WCEROOT%"=="" set WCEROOT=C:\Program Files\Microsoft eMbedded C++ 4.0
if "%SDKROOT%"=="" set SDKROOT=C:\Windows CE Tools

set PATH=%WCEROOT%\COMMON\EVC\bin;%WCEROOT%\EVC\%OSVERSION%\bin;%path%
set INCLUDE=%SDKROOT%\%OSVERSION%\%PLATFORM%\include\emulator;%SDKROOT%\%OSVERSION%\%PLATFORM%\MFC\include;%SDKROOT%\%OSVERSION%\%PLATFORM%\ATL\include;
set LIB=%SDKROOT%\%OSVERSION%\%PLATFORM%\lib\emulator;%SDKROOT%\%OSVERSION%\%PLATFORM%\MFC\lib\x86;%SDKROOT%\%OSVERSION%\%PLATFORM%\ATL\lib\x86;

set CC=cl.exe

set TARGETCPU=emulator
set CFG=none

